// *****************************************************************************
//
// source:    AC_SVD_init.C  C&A routine int of VDS 
//
// type:      source code
//
// created:   03 Nov 1999
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    AC_SVD_init()
//
// called by: AC_init()
//
// hints:     see $HBROOT/ARTE/dev/include/dq/DQ.h for COMP_XYZ and LVL_ABC
//
// changes:
// 03 Nov 1999 (AG)  further developments
// 19 Nov 1999 (AG)  cna -> ac (alca)
// 22 Nov 1999 (AG)  includes in alca
// 10 Dez 1999 (MBr) include of user part
// 04 Aug 2000 (MAP) alignment ntuple only
// 05 Aug 2000 (AG)  added function name to printout
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ONLINE includes
#include "rhp.h"
#include "grr.h"

// Arte includes
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "alca/AC_SVD.hh"
#include "alca/AC_vdsalign_hist.h"

//
// program code
//
int
AC_SVD_init() 
{
  ARTE_mark( "AC_SVD_init 0", 0 );
  cout << "AC_VDS_init()" << endl;
  
  
  // book alignment NTUPLE
  int chknt = GRR_INVALID;
  
  chknt = rhp_hbookn2(AC_ID(COMP_SVD,LVL_TST,ALIGN_DATA_NT),"VDS alignment NTUPLE","cog:side",RHP_MAXCOL);
  if (chknt == GRR_OK) cout << "AC_SVD_init: Booked ntuple for alignment!" << endl;
  else if(chknt == GRR_DEFINED) cout << "AC_SVD_init: ===========> WARNING: ID already
in use" << endl;
  else if(chknt == GRR_INVALID) cout << "AC_SVD_init: ===========> WARNING: invalid
input parameter" << endl;
  else if(chknt == GRR_FISHY) cout << "AC_SVD_init: ===========> WARNING: not enough
memory for ntuple!" << endl;
  else cout << "AC_SVD_init: ===========> WARNING: couldn't book alignment ntuple!!!"
<< endl;

  ARTE_mark( "AC_SVD_init 1", 0 );  
  return 0;
}




