// ********************************************************************
//
//  Routine:      ackaread
//  Author:       T.Oest
//
//  Description:  switch on/off reading of alignment constants
//
//  Modifications:
//  09 May 2000 (AG) use faComp() tpo check componenets
// 
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "arte/arte.hh"
#include "farm/farm.hh"

int acFlagReadVDS  = 1;
int acFlagReadITR  = 1;
int acFlagReadOTR  = 1;
int acFlagReadRICH = 1;
int acFlagReadECAL = 1;
int acFlagReadMUON = 1;

extern int FADEB;

extern "C" void kugetc_( char*, int *, int );

extern "C" void ackaread_() {   

//---------------------------------------------------------------
//   read in subdetector
//---------------------------------------------------------------

  int len;        
  int len1 = 6;
  char input[7];
  kugetc_(input, &len, len1);
  input[len] = 0;


  char *subdetector;
  subdetector  = (char *) malloc(len+1);
  subdetector[len]  = 0;

  for(int i=0; i<len; i++) subdetector[i] = toupper(input[i]);

//---------------------------------------------------------------
//   read in subdetetcor status
//---------------------------------------------------------------

  len1 = 3;
  kugetc_(input, &len, len1);
  input[len] = 0;

  char *status;
  status  = (char *) malloc(len+1);
  status[len] = 0;

  if(len>0) for(int i=0; i<len; i++) status[i] = toupper(input[i]);


//---------------------------------------------------------------
//   read in date and time
//---------------------------------------------------------------

  int istatus;

  if (!strncmp(status,"ON",2)){
    istatus = 1;
  } else {
    istatus = 0; 
  };

   if (!strncmp(subdetector,"VDS",3)||!strncmp(subdetector,"SVD",3))
                                         acFlagReadVDS  = istatus;
   if (!strncmp(subdetector,"OTR" ,3))   acFlagReadOTR  = istatus;
   if (!strncmp(subdetector,"ITR" ,3))   acFlagReadITR  = istatus;
   if (!strncmp(subdetector,"ECAL",4))   acFlagReadECAL = istatus;
   if (!strncmp(subdetector,"RICH",4))   acFlagReadRICH = istatus;
   if (!strncmp(subdetector,"MUON",4))   acFlagReadMUON = istatus;

//-----------------------------------------------------------------------------
// disable components if not present in run (faComp() returns 1 for offline)
//-----------------------------------------------------------------------------

   acFlagReadVDS  = faComp( COMP_M_SVD  ) ? acFlagReadVDS  : 0;
   acFlagReadITR  = faComp( COMP_M_ITR  ) ? acFlagReadITR  : 0;
   acFlagReadOTR  = faComp( COMP_M_OTR  ) ? acFlagReadOTR  : 0;
   acFlagReadRICH = faComp( COMP_M_RICH ) ? acFlagReadRICH : 0;
   acFlagReadECAL = faComp( COMP_M_ECAL ) ? acFlagReadECAL : 0;
   acFlagReadMUON = faComp( COMP_M_MUON ) ? acFlagReadMUON : 0;

//-----------------------------------------------------------------------------
// print
//-----------------------------------------------------------------------------

   if( FADEB ){
     cout << "KUIP: AC READ flags:"          << endl;
     cout << "      VDS= " << acFlagReadVDS  << endl;
     cout << "      ITR= " << acFlagReadITR  << endl;
     cout << "      OTR= " << acFlagReadOTR  << endl;
     cout << "      RICH=" << acFlagReadRICH << endl;
     cout << "      ECAL=" << acFlagReadECAL << endl;
     cout << "      MUON=" << acFlagReadMUON << endl;
   }

}
