*-- Author :    Hartwig Albrecht   29/03/95

      SUBROUTINE MMRTAB (LUN, IHD, JLN)

************************************************************************
*
* Description: Read next Zebra table header with FZIN option 'S'
*
* Called from: MMREAD
*
* External references:
*
* Argument in/out description
*   LUN    in     logical unit
*   IHD    in     0: no header table yet read in
*   JLN    out    >0: link number of the table
*                  0: end of event
*                 -1: end of data
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEMO.fi"
#include "auto/MEIO.fi"
#include "arte/ZQUEST.fi"

      INTEGER LUN, IHD, JLN, NUH, IUH(20), HEVHD, DUMMY

      CHARACTER CN*80

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEIO.ff"

      CALL CHCTOH ('EVHD', HEVHD, 1)
 10   IF (IMEIO_TABLE(LUN) .EQ. 0)  GO TO 20

C process information from previous record

      JLN = IMEIO_TABLE(LUN)
      IF (JLN .GT. 0)  THEN
        IQ(IQMEIO_TABLE(LUN)) = 0
        GO TO 200
      END IF

      IQ(IQMEIO_TABLE(LUN)) = 0
      CALL IOCLOS (LUN)

C open new file if necessary
      
 20   IF (IHD .EQ. 0)  THEN
        CALL MMOPEN (LUN, -1, JLN)
        IF (JLN .LT. 0)  GO TO 990

C read next event header (GPACK)

        IF (IMEIO_PACK(IMEIO_CURRENT(LUN)) .EQ. 2) THEN
 30        CALL GARTRNEXT (LUN, IQUEST(1))
           IF (IQUEST(1)) 40, 41, 55
C                        err  ok eod

 40        C78 = 'MMREAD (GPACK): read next event header: error. rc ='
           CALL CH78BI (IQUEST(1))
           CALL ME78MC (46586, ILARGEST, 10)
           CALL USRERR (LUN)
           GO TO 30
 41        CONTINUE
           IF(IMEIO_NSKIP(LUN).GT.0) THEN
              IQ(IQMEIO_NSKIP(LUN)) = IMEIO_NSKIP(LUN) - 1
           ENDIF
        ENDIF
      END IF
      
      IF (IMEIO_PACK(IMEIO_CURRENT(LUN)) .EQ. 2) THEN
 43      DO WHILE (IMEIO_NSKIP(LUN) .GT. 0)
            CALL GARTRNEXT (LUN, IQUEST(1))
            IF (IQUEST(1)) 45, 47, 55
C                         err  ok eod

C     Error processing
 45         C78 = 'MMREAD (GPACK): read next event header: error. rc ='
            CALL CH78BI (IQUEST(1))
            CALL ME78MC (46586, ILARGEST, 10)
            CALL USRERR (LUN)
            GO TO 43

C     OK
 47         IQ(IQMEIO_NSKIP(LUN)) = IMEIO_NSKIP(LUN) - 1
         ENDDO                
      ENDIF
         
C read table identification

 50   NUH = 2
      
      IF (IMEIO_PACK(IMEIO_CURRENT(LUN)) .EQ. 1) THEN
        CALL FZIN (LUN, DUMMY, DUMMY, DUMMY, 'S', NUH, IUH)
      ELSE
        CALL GARTRTAB (LUN, IUH(1), IQUEST(1)) 
        IF (IQUEST(1) .EQ. 5) THEN ! if End of Data
          JLN = -1
          GO TO 900
        ELSE IF (IQUEST(1) .EQ. 100) THEN ! end of event
          JLN = 0
          GO TO 900
        ENDIF
      END IF

      IF (IQUEST(1) .EQ. 0)  GO TO 60

C read error ?

      IF (IQUEST(1) .LT. 0)  THEN

        C78 = 'MMRTAB: read error. IQUEST(1) ='
        CALL CH78BI (IQUEST(1))
        CALL ME78MC (111, ILARGEST, 10)
        CALL USRERR (LUN)
        GO TO 50

C Zebra start/end-of-run record (I dont know what to do with it)

      ELSE IF (IQUEST(1) .LE. 2)  THEN
        GO TO 50
      END IF

C End of data (file ?)

      IF (IQUEST(1) .GE. 4)  THEN
        CALL IOCLOS (LUN)
      END IF
      
C  IQUEST(1) == 3  -> Set flag "end-of-file"
      IQ(IQMEIO_FLAG(IMEIO_CURRENT(LUN))) = 4
      IQ(IQMEIO_TABLE(LUN)) = -1
      JLN = 0
      GO TO 900

C End of data (file ?)

 55   CALL IOCLOS (LUN)
      GO TO 20

C record header: 2 words requested

 60   IF (NUH .NE. 2 .OR. IUH(1) .EQ. 0)  THEN
        CALL MEERRC (333,
     +    'MMRTAB: bank identification incorrect. Dont use MMREAD')
        GO TO 20
      END IF

C which link ? (space for future program improvement !)

      DO JLN = 1, NARLNK
        IF (HMEMO_NAME(1,JLN) .EQ. IUH(1))  GO TO 100
      END DO

C unknown bank: (space for future program improvement !)

      CALL CHHTOC (IUH(1), CN)
      C78 = 'MMRTAB: unknown table name. table skipped:'
      CALL CH78BC (CN)
      CALL ME78EC (444)
      IF (IMEIO_PACK(IMEIO_CURRENT(LUN)) .EQ. 2) THEN
        CALL GARTSKIPTAB (LUN,IQUEST(1))
      ENDIF
      GO TO 20

C new event ?

 100  IF (IQUEST(11) .NE. 0 .AND. IMEMO_SUP(1,JLN) .NE. 0)  THEN
        C78 = 'MMRTAB: table'
        CALL CHHTOC (IUH(1), CN)
        CALL CH78BC (CN)
        CALL CH78BC ('is a record header on input but not in ARTE')
        CALL ME78PC (666, 30)
      END IF

C record header table ?

 110  IF (IMEMO_SUP(1,JLN) .NE. 0)  GO TO 200
      IQ(IQMEIO_FLAG(IMEIO_CURRENT(LUN))) = 3

      IF (IMEIO_NSKIP(LUN) .EQ. 0)  GO TO 130

C Skip records.
C On event files: skip event records, accept all other records

      IF (IUH(1) .EQ. HEVHD)  GO TO 120
      IF (LUN .NE. LEVI1 .AND. LUN .NE. LEVI2 .AND.
     +    LUN .NE. LEVI3 .AND. LUN .NE. LEVI4)  GO TO 120
      IQ(IQMEIO_FSKIP(LUN)) = 0
      GO TO 130

 120  IQ(IQMEIO_NSKIP(LUN)) = IMEIO_NSKIP(LUN) - 1
      IQ(IQMEIO_FSKIP(LUN)) = 1

C end of event: extra return with JLN = 0

 130  IQ(IQMEIO_TABLE(LUN)) = JLN
      JLN = 0
      GO TO 900

C test if bank is selected for input

 200  IF (BITTEST (BMEMO_IOA(JLN), 1) .EQ. 0 .OR.
     +    BITTEST (BMEMO_IOA(JLN), HMEIO_BIT(LUN)) .EQ. 0)  THEN
        IF (BITTEST (BMEMO_IOD(JLN), HMEIO_BIT(LUN)) .EQ. 0 .AND.
     +      IMEMO_FLAG(JLN) .NE. 4)  THEN
          C78 = 'MMRTAB: bank'
          CALL CHHTOC (IQ(HQMEMO_NAME(1,JLN)), CN)
          CALL CH78BC (CN)
          CALL CH78BC ('not expected on')
          CALL CHHTOC (IQ(HQMEIO_STREAM(1,IMEIO_CURRENT(LUN))), CN)
          CALL CH78BC (CN)
          IF (JLINK(JLN) .EQ. 0)  GO TO 210
          IF (N_U(JLINK(JLN)) .EQ. 0)  THEN
            CALL MMDROP (JLINK(JLN))
            GO TO 210
          END IF
          CALL CH78AC (' - skipped')
          CALL ME78EC (888)
          IF (IMEIO_PACK(IMEIO_CURRENT(LUN)) .EQ. 2)
     +      CALL GARTSKIPTAB (LUN, IQUEST(1))
          GO TO 20

 210      CALL ME78PC (7634, 30)
        END IF
      END IF

 900  IF (IMEIO_NSKIP(LUN) * IMEIO_FSKIP(LUN) .NE. 0)  GO TO 10
      IF (JLN .EQ. 0)  IQ(IQMEIO_NREC(IMEIO_CURRENT(LUN))) = 
     +                 IQ(IQMEIO_NREC(IMEIO_CURRENT(LUN))) + 1

 990  END

************************************************************************
* End of MMRTAB
************************************************************************
