// ******************************************************************
//
// r. spighi 25 jan 2000
//
// Filling of histograms
//
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_ECAL.h"

#include <CLHEP/Hist/HBookHistogram.h>


struct ETMAX
{
  double etmax;
  double emax;
  double xetmax;
  double yetmax;
};


//
// function code
//
int
DQ_ECAL_hit_evnt(){

  double E_sum[4] = {0.,0.,0.,0.};
  double TotalHITCEnergy = 0;
  double ThisEt;
  double E_bx = 0.;  

  ETMAX etmaxcal[3] = {{0.,0.,0.,0.},{0.,0.,0.,0.},{0.,0.,0.,0.}}; //ETmax
                                                           // In mid Out

  int TotalHITCcell=0;
  int typecal = 0, fed;
  static double TotalHITCEnergyave[4] = {0.,0.,0.,0.};
  static int n_mon  = -1; 
  static int num_ev = 0;
  static int trigger_mostprobable[20]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
  float thr_hitcell[3]={0.6,0.4,0.2};

  num_ev++;                            // sequential number
  int tcode = faDDAQFCS_tcode();       // tcode
  float targetrate = faDTARia();       // target rate
  float interactionrate = 0;
  interactionrate = targetrate/10.;


  if(tcode >=0 && tcode < 20 ) trigger_mostprobable[tcode]++;
  //for(int i=0;i<20;i++) cout<<"tr most prob "<<trigger_mostprobable[i]<<endl;

  //  cout<<"targetrate  "<<targetrate<<" Int rate "<<interactionrate<<endl;

  int i=0;

  //    
  // loop over all hitc to fill histogram
  //
  for( ArteTableIterator<HITC> hitc1; hitc1.valid(); hitc1.next() ){
    //    ArtePointer<GCCE> gcce = hitc1->gcce;
    //    ArtePointer<ECHF> echf(gcce.index());
    
    TotalHITCEnergy+=hitc1->q;
    TotalHITCEnergyave[0]+=hitc1->q;
    
    TotalHITCcell++;   // total cells
    
    fed = ArtePointer<ECHS>((hitc1->gcce).index())->fdid;
    
    if(fed < 100) 	               typecal = 1;  //inner
    if(fed >= 100 && fed < 180)      typecal = 2;  //middle
    if(fed >= 180)                   typecal = 3;  //outer
  
    if (typecal != 0) TotalHITCEnergyave[typecal]+=hitc1->q;
    
    if (typecal != 0) {
      //      E_sum[typecal-1]+=hitc1->q;
      if(hitc1->q > 1.) E_sum[typecal-1]+=hitc1->q;
      if(hitc1->q > 1.) E_bx += hitc1->q;
    }

    ThisEt=hitc1->q *sqrt(hitc1->x*hitc1->x+hitc1->y*hitc1->y)/
      sqrt(1341*1341+hitc1->x*hitc1->x+hitc1->y*hitc1->y); //Et
    
    if(ThisEt>etmaxcal[typecal-1].etmax && typecal != 0){  // Et max
      etmaxcal[typecal-1].etmax = ThisEt;
      etmaxcal[typecal-1].emax = hitc1->q;
      etmaxcal[typecal-1].xetmax = hitc1->x;
      etmaxcal[typecal-1].yetmax = hitc1->y;
    }
    
    
    // cell energy and energy_t
      rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,110),hitc1->q,1); 
      rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,111),ThisEt,1); 

    // occupancy 
      if(typecal != 0) {
	if(hitc1->q > thr_hitcell[typecal-1]){
	  rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,769+typecal),hitc1->x,hitc1->y,1.);

    // occupancy per radius square
	  float weight = (hitc1->x*hitc1->x + hitc1->y*hitc1->y)/targetrate;
	  rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,774+typecal),hitc1->x,hitc1->y,weight);

    // Energy density 
	  rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,754+typecal),hitc1->x,hitc1->y,hitc1->q);
	}
      }
      
  }  // end loop HITC


  // Statistic in the first bin of histogram  

    rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,770),-78.,-44.,1.);
    rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,771),-223.,-133.,1.);
    rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,772),-312.,-234.,1.);

    rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,775),-78.,-44.,1.);
    rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,776),-223.,-133.,1.);
    rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,777),-312.,-234.,1.);

    rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,755),-78.,-44.,1.);
    rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,756),-223.,-133.,1.);
    rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,757),-312.,-234.,1.);


  // XY for EtMax
  for(i=0;i<3;i++){
    E_sum[3] += E_sum[i];
    if(etmaxcal[i].xetmax != 0) 
      rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,780+i),
		etmaxcal[i].xetmax,etmaxcal[i].yetmax,1);
    
    rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,100+i),E_sum[i],1); //En in mid out
  }
  
  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,103),E_sum[3],1);
  
  // all energy 
  if (num_ev>0 && num_ev%100 == 0) {
    n_mon += 1;
    //    if(typecal != 0)  n_mon[typecal] += 1;
    //    if(n_mon >999) n_mon = n_mon - (n_mon/1000)*1000;

    int indmax = 0;
    int tmax = 0;
    for(int jj=0;jj<20; jj++){
      if(trigger_mostprobable[jj] > tmax) {
	tmax = trigger_mostprobable[jj];
	indmax = jj;
	//	cout<<"ind max  "<<indmax<<"   num trig   "<<tmax<<endl;
      }
    }
    for(i=0;i<4;i++) {
      if(n_mon > 999) n_mon = 0;
      if(interactionrate < 0.1) interactionrate = 1.;
      float tmp = 0.;
//      if(tcode != 0) tmp = TotalHITCEnergyave[i]/(100.*interactionrate);
      if(indmax != 0) tmp = TotalHITCEnergyave[i]/(100.*interactionrate);
      else{
	if(interactionrate <= 1.2) tmp = TotalHITCEnergyave[i]/(100.);
	else tmp = TotalHITCEnergyave[i]/(100.*interactionrate);
      }

      //      float tmp = TotalHITCEnergyave[i]/(100.*interactionrate);

      rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,13+i),float(n_mon),tmp);



//      cout<<"TotalHITCEnergyave[i]  "<<TotalHITCEnergyave[i]<<endl;
//      cout<<"TotalHITCEnergyave[i](100*interactionrate)  "<<tmp<<endl;

      TotalHITCEnergyave[i] = 0;	
    }
  }
  
  ArtePointer<DIHD>dihd(1);
  int BXnumber = dihd->bx;
//  cout<<"BXnumber "<<BXnumber <<endl;  

  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,9), float(BXnumber),1);            // BX
  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,9),220.2,1);
  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,104),float(BXnumber),E_sum[3]);
  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,105),float(BXnumber),E_bx);
  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,104),220.2,1);

  rhp_hf1(DQ_ID( COMP_ECAL, LVL_HIT,10), float( tcode ), 1 );    // tcode
  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,11), float(TotalHITCcell),1);     // nr cell


  return 0; // return error code (0 = okay)

}







