
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
// 01 Nov 1999 (AG) get rid of dq_hid.h
// 01 Nov 1999 (AG) commented out TDC spectra histograms
// 19 Nov 1999 (AG) show up
//  6 Jul 2000 (AG) polished printout
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_OTR.h"

//
// function code
//
int
DQ_OTR_hit_init()
{
  // show up
  ARTE_mark( "DQ_OTR_hit_init 0", 0 ); 
  cout << "DQ_OTR_hit_init" << endl;

  char HistName[100];
  char HistTitle[100];
  int  HistID;
  char oldtitle[RHP_TITLE_LEN];
  int oldbins;
  float oldxmin;
  float oldxmax;
  int oldhist;
  float newxmin;
  float newxmax;
  int nbin;
//======================================================================
//         OTR
//======================================================================

  for(ArteTableIterator<GESL> gesl;gesl.valid();gesl.next()){

    // MC01    
    if(strncmp(gesl->name,"MC01",4)==0){ 
      
      rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,100100),"OTR: hits per sector in MC01",
		 gesl->npl,gesl->fpl-0.5,gesl->fpl+gesl->npl-0.5);
      for(ArteTableIterator<GEDE> gede(gesl->fpl);
	  gede.index()<(unsigned int)(gesl->fpl+gesl->npl);gede.next()){
	
	nbin=gede->nwi[0]+gede->nwi[1];
	
	if(gede->nwi>0) // only 'physical modules
	  {
	    HistID=gede->sec+10*(gede->lay-1)-1;
	    if(HistID<30){
	      
	      // --- it exists already - update parameters
	      if(rhp_hexist(DQ_ID(COMP_OTR,LVL_HIT,100000+HistID))){ 
		
		oldhist=rhp_hgive1(DQ_ID(COMP_OTR,LVL_HIT,100000+HistID),
				   oldtitle,&oldbins,&oldxmin,&oldxmax);
		newxmin= (oldxmin < gede->xfw[0] ? oldxmin :gede->xmin); 
		newxmax= (oldxmax > gede->xmax? oldxmax :gede->xmax );
		
		//rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,100000+HistID),oldtitle,
		//   gede->nwi[0]+gede->nwi[1]+oldbins,
		//   newxmin,newxmax);
	      }
	      else
		{
		  if(nbin>0){
		    sprintf(HistName,"OTRMC01Occ_%d_%d",
			    gede->sec,gede->lay);
		    sprintf(HistTitle,"OTR: Occupancy %s, SEC %d LAY %d",
			    gesl->name,gede->sec,gede->lay);
		    
		    
		    //rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,100000+HistID),HistTitle,
		    //       gede->nwi[0]+gede->nwi[1],
		    //       gede->xmin,gede->xmax);
		    sprintf(HistName,"OTRMC01TDC_%d_%d",gede->sec,gede->lay);
		    sprintf(HistTitle,"OTR: TDC Spectrum %s, SEC %d LAY %d",
			    gesl->name,gede->sec,gede->lay);
		    
		    //rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,110000+HistID),
		    //       HistTitle,260,-0.5,259.5);
		  }
		}
	      
	    }
	  }
      }
    }
    
    // MC02
    if(strncmp(gesl->name,"MC02",4)==0){ 
      
      rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,200100),"OTR: hits per sector in MC02",
		 gesl->npl,gesl->fpl-0.5,gesl->fpl+gesl->npl-0.5);
      for(ArteTableIterator<GEDE> gede(gesl->fpl);
	  gede.index()<(unsigned int)(gesl->fpl+gesl->npl);gede.next()){
	if(gede->nwi>0) // only 'physical modules
	  {
	    
	    nbin=gede->nwi[0]+gede->nwi[1];
	    
	    HistID=gede->sec+10*(gede->lay-1)-1;
	    if(HistID<30)
	      {
		// --- it exists already - update parameters
		
		if(rhp_hexist(DQ_ID(COMP_OTR,LVL_HIT,200000+HistID))){
		  
		  rhp_hgive1(DQ_ID(COMP_OTR,LVL_HIT,200000+HistID),
			     oldtitle,&oldbins,&oldxmin,&oldxmax);
		  
		  newxmin= (oldxmin < gede->xfw[0] ? oldxmin :gede->xmin); 
		  newxmax= (oldxmax > gede->xmax? oldxmax :gede->xmax );
		  
		  //rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,200000+HistID),oldtitle,
		  //     gede->nwi[0]+gede->nwi[1]+oldbins,
		  //     newxmin,newxmax);
		  
		}
		else
		  {
		    if(nbin>0){
		      sprintf(HistName,"OTRMC02Occ_%d_%d",gede->sec,gede->lay);
		      sprintf(HistTitle,"OTR: Occupancy %s, SEC %d LAY %d",
			      gesl->name,gede->sec,gede->lay);
		      
		      //rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,200000+HistID),HistTitle,
		      //	 gede->nwi[0]+gede->nwi[1],gede->xmin,gede->xmax);
		      sprintf(HistName,"OTRMC02TDC_%d_%d",gede->sec,gede->lay);
		      sprintf(HistTitle,"OTR: TDC Spectrum %s, SEC %d LAY %d",
			      gesl->name,gede->sec,gede->lay);
		      
		      //rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,210000+HistID),
		      //	 HistTitle,260,-0.5,259.5);
		    }
		  }
	      }
	  }
      }
    }

    // PC04
    if(strncmp(gesl->name,"PC04",4)==0){
      rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,300100),"OTR: hits per sector in PC04",
		 gesl->npl,gesl->fpl-0.5,gesl->fpl+gesl->npl-0.5);
      for(ArteTableIterator<GEDE> gede(gesl->fpl);
	  gede.index()<(unsigned int)(gesl->fpl+gesl->npl);gede.next()){
	
	nbin=gede->nwi[0]+gede->nwi[1];
	
	HistID=gede.index()-gesl->fpl;
	if(HistID<36)
	  {
	    sprintf(HistName,"OTRPC04Occ_%d_%d",gede->sec,gede->lay);
	    sprintf(HistTitle,"OTR: Occupancy %s, SEC %d ANGLE %d",
		    gesl->name,gede->sec,gede->lay);
	    //rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,300000+HistID),HistTitle,
	    //       1+gede->nwi[0]+gede->nwi[1],
	    //       gede->xfw[0]-gede->pit/2,
	    //       gede->xfw[0]+(gede->nwi[0]+gede->nwi[1]-1)*gede->pit/2);
	    
	    sprintf(HistName,"OTRPC04TDC_%d_%d",gede->sec,gede->lay);
	    sprintf(HistTitle,"OTR: TDC Spectrum %s, SEC %d ANGLE %d",
		    gesl->name,gede->sec,gede->lay);
	    //rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,310000+HistID),
	    //       HistTitle,260,-0.5,259.5);
	  }
      }
    }
    
    // TC01
    if(strncmp(gesl->name,"TC01",4)==0){
      rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,400100),"OTR: hits per sector in TC01",
		 gesl->npl,gesl->fpl-0.5,gesl->fpl+gesl->npl-0.5);
      for(ArteTableIterator<GEDE> gede(gesl->fpl);
	  gede.index()<(unsigned int)(gesl->fpl+gesl->npl);gede.next()){
	HistID=gede.index()-gesl->fpl;
	if(HistID<36&&gede->nwi>0)
	  {
	    nbin=gede->nwi[0]+gede->nwi[1];
	    
	    if(nbin>0){
	      sprintf(HistName,"OTRTC01Occ_%d_%d",gede->sec,gede->lay);
	      sprintf(HistTitle,"OTR: Occupancy %s, SEC %d ANGLE %d",
		      gesl->name,gede->sec,gede->lay);
	      
	      //rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,400000+HistID),HistTitle,
	      //	 1+gede->nwi[0]+gede->nwi[1],
	      //	 gede->xfw[0]-gede->pit/2,
	      //	 gede->xfw[0]+(gede->nwi[0]+gede->nwi[1]+1)*gede->pit/2);
	      
	      sprintf(HistName,"OTRTC01TDC_%d_%d",gede->sec,gede->lay);
	      sprintf(HistTitle,"OTR: TDC Spectrum %s, SEC %d ANGLE %d",
		      gesl->name,gede->sec,gede->lay);
	      //rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,410000+HistID),
	      //	 HistTitle,260,-0.5,259.5);
	    }
	  }
      }
    }

    // TC02
    if(strncmp(gesl->name,"TC02",4)==0){
      rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,500100),"OTR: hits per sector in TC02",
		 gesl->npl,gesl->fpl-0.5,gesl->fpl+gesl->npl-0.5); 
      for(ArteTableIterator<GEDE> gede(gesl->fpl);
	  gede.index()<(unsigned int)(gesl->fpl+gesl->npl);gede.next()){
	HistID=gede.index()-gesl->fpl;
	if(HistID<36&&gede->nwi>0){
	  nbin=gede->nwi[0]+gede->nwi[1];
	  
	  
	  if(nbin>0){
	    sprintf(HistName,"OTRTC02Occ_%d_%d",gede->sec,gede->lay);
	    sprintf(HistTitle,"OTR: Occupancy %s, SEC %d ANGLE %d",
		    gesl->name,gede->sec,gede->lay);
	    //rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,500000+HistID),HistTitle,
	    //       1+gede->nwi[0]+gede->nwi[1],gede->xfw[0]-gede->pit/2,
	    //       gede->xfw[0]+(gede->nwi[0]+gede->nwi[1]-1)*gede->pit/2);
	    
	    sprintf(HistName,"OTRTC02TDC_%d_%d",gede->sec,gede->lay);
	    sprintf(HistTitle,"OTR: TDC Spectrum %s, SEC %d ANGLE %d",
		    gesl->name,gede->sec,gede->lay);
	    //rhp_hbook1(DQ_ID(COMP_OTR,LVL_HIT,510000+HistID),
	    //       HistTitle,260,-0.5,259.5);
	  }
	}
      }
    }
    
  } 
  
  // show up
  ARTE_mark( "DQ_OTR_hit_init 1", 0 ); 

  return 0; // return error code (0 = okay)
}
