
// *****************************************************************************
//
// source:    DQ_stop.C
//
// type:      source code
//
// created:   01 Aug 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    DQ_stop
//
// called by: acstop_
//
// purpose:   terminate DQ monitoring
//
// hints:
//
// changes:
// 01 Aug 2000 (AG) creation
// 07 Aug 2000 (AG) get kumac name
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ONLINE includes

// ARTE includes
#include "arte/ArteFlag.h"
#include "farm/farm.hh"

// externals
extern int DQ_DBS;

// prototypes
void DQ2DBS();
void WriteTstDetails( int major, int minor );

//
// function code
//
int
DQ_stop()
{
  ARTE_mark( "DQ_stop 0", 0 );
  cout << "DQ_stop" << endl;
  
  // write to DB
  if( DQ_DBS ){
    ARTE_mark( "DQ2DBS", 0 );
    cout << "DQ_stop: DQ2DBS" << endl;
    DQ2DBS();
  }

  // kumac name
  //arteflag_.progname;
  
  ARTE_mark( "DQ_stop 1", 0 );
  return 0;
}
