//                              -*- Mode: C++ -*-
//
// LkParticle.h -- A Lockable Particle class (for doing Particle combinatorics)
//
// $Id: DQ_LkParticle.hh,v 1.1 2000/04/19 20:42:16 natasha Exp $
//
// Copyright (C)  1993  The Board of Trustees of The Leland Stanford
//                                  Junior University.  All Rights Reserved.
//
// Creator         : Tom Pavel  <pavel>     Thu Oct 21 10:05:52 1993
// Modifier        : Tom Pavel  <pavel>     Thu Oct 21 11:27:58 1993
// Update Count    : 2
// Status          : Unknown, Use with caution!
//

#ifndef _LkParticle_h_
#define _LkParticle_h_

#ifdef __GNUG__
#pragma interface
#endif

//#define HEP_SHORT_NAMES
//#include <CLHEP/Combination/Lockable.h>
//#undef HEP_SHORT_NAMES
#include "dq/DQ_Particle.hh"
#include "dq/DQ_util.hh"
#include <CLHEP/Combination/Lockable.h>

class LkParticle : public HepLockable, public Particle {
public:
   LkParticle() {}
   LkParticle(const Particle& p) : Particle(p) {}
   LkParticle(const LkParticle& p) : Particle(p) {}
   virtual ~LkParticle();

   virtual int isA(ClassId id);

   static ClassId ClassID() { static int x; return &x; }

   virtual LkParticle& operator += (const LkParticle& p)
        { Particle::operator+=(p);   return *this; }
   LkParticle operator+ (const LkParticle& p)
        { LkParticle sum = *this; sum += p; return sum; }
   virtual LkParticle & operator = (const LkParticle& p)
        { Particle::operator=(p); return *this;}
  virtual  LkParticle* child(int i) const 
  { return (LkParticle*) Particle::child(i);}

protected:
   // These are for the benefit of Lockable:
   virtual HepLockable *lockableChild(int i) const;

   virtual int nLockChildren() const; 

};

#endif  /* _LkParticle_h_ */
