
/***********************************************************************
* CRGEDE
* written by Siegmund Nowak
*
* This routine books and fills the detector bank GEDE
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* var1        in           this variable will only be read
***********************************************************************/
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "gean/gcvolu.h"
#include "gean/Geant2Arte.hh"

extern "C" {
void crgede_(char name[],int & ilay, int & isec) {
    Geant2Arte G2A;

//  Book NEDE bank and connect it to NESL bank 
    int  nnede = G2A.CreateNede();
    ArtePointer<NEDE> nd(nnede);

//  get detector volume nr ivol 
    int ivos = G2A.GetGvolNumber(name);
    if(ivos == 0) { 
       arteMsg << "crgede >> nonvalid volume " << name; arteMsg.error();
    } 
         
    G2A.FillTree(name,nnede);
    G2A.FillGvolParameter(); 
    G2A.FillNedeParameter(nnede);

    nd->lay = ilay;
    nd->sec = isec;

    gcvolu_.nlevel =0;
}
}

