#ifndef _ZGPOS_HH_
#define _ZGPOS_HH_
#include "gean/zgeom.hh"
#include <vector.h>

  typedef struct {
    int   index_hgvol;
    int   ctyp;
    int   sector;
    int   layer;
    int   rotm;
    float xpos, ypos, zpos;
    float rot_px, rot_py, rot_pz;
    char  comp   [4];
    char  only   [4];
    } hgpos;

class zgpos : zgeom {
public:

  friend class zgdet;
  friend class zgrot;  
  friend class zgvol;
  friend class zguser;

  zgpos() {}
  ~zgpos() {} 
  
  void ini(int n);
  void fin();
  void  Read_comp(char*);
  void  Read_resolve(char*);
  void  Read_Mirror_x();
  void  Read_Mirror_y();  
  void  Read_Mirror_z();

  void  Set_default();
  void  Set_vol_pos_Rel();
  void  Copy_previous();

  char* Get_posname(int,int,int &);
  int   Get_RotPos(const int,const int,float &,float &,float &,int &);
  int   Get_layer(int,int);
  int   Get_sector(int,int);  
   
  int   Select_pos(char *,int);

  void  Gposit_all(int &,int &); 
  void  Gposit_superlayer(char *,int &, int &);
  int   Check_superlayer(char *,float &,float &,float &);

  int   Check_Gpos(char*);  

private:
  static  vector<hgpos>  *ptpos[33];
};

#endif






