*CMZ :          13/05/96  14.34.35  by  Fedor Ratnikov
*CMZ :  1.00/08 08/11/95  15.32.04  by  Fouzia SAADI
*CMZ :  1.00/01 09/06/95  14.14.55  by  Dominik Ressing
*CMZ :  1.00/00 29/01/95  22.17.17  by  Fedor Ratnikov
*CMZ :  0.01/03 18/09/94  22.40.08  by  Fedor Ratnikov
*CMZ :  0.01/02 11/09/94  21.26.58  by  Fedor Ratnikov
*-- Author :
************************************************************************
*
* L1PREEF
* written by Dominik Ressing, 11/08/94 10.23.08
*
* This routines action:
* Performes fast simulation of the ECAL pretriggers for the
* current BX L1RUNcuBX
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* iP          in          pointer to processor definition for this pretrigger
* ierr        out         set to <>0 on error
*
************************************************************************
c
      SUBROUTINE L1PREEF(iP,ierr)
c
      IMPLICIT NONE
c
#include "gean/gcbank.fi"
#include "l1si/l1runpa.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1jobdf.fi"
#include "l1si/l1prcdf.fi"
c
      INTEGER ierr,iP
c
      REAL     T1HITAM,T1ECACU,T1ECACV
      INTEGER  L1DETSL,JBYT
      EXTERNAL T1HITAM,L1DETSL,JBYT,T1ECACU,T1ECACV
c
           INTEGER MessPo,JobPo,iPRE,isec,nsec,
     &        MaxNei,   ! maximal number of neighbours
     &        iPoPo,    ! pretrigger point pointer
     &        iTime     ! time after Pretrigger
c
      INTEGER  L1GAMCU
      EXTERNAL L1GAMCU
      INTEGER  ipo1,ipo2,ipo3
      REAL     dxi,ddxi
c
      PARAMETER(MaxNei=20)
c
      INTEGER iCalo,iECAL,igeneral,nNeigh,icell,iborder,
     &        igenNei,iNeiInfo,nCellTotal,iCalo0,iNei,iInfo,
     &        ndim,ndim0,iDetKAL,icharge,igbrem,iNeiBrem,neiDet,
     &        iX,iY,iXCell,iYCell,iModuleX,iModuleY,iXCell0,iYCell0,
     &        iXborder,iYborder,iXbrem,iYbrem,iPoCog,iTrk,
     &        iHitPoi,iCardX,iCardY,iCardX0,iCardY0,
     &        ioverlap
      REAL    BASE_SIZE,CELL_SIZE,E0,Eclu,CUT,
     &        Ebrem,Explus,Exminus,Eyplus,Eyminus,Ecog,
     &        X0Cell,Y0Cell,X0Clust,Y0Clust,rX,rY,xBrem,yBrem,
     &        dxBrem,dyBrem,xPo,yPo,zPO,xCo,yCo,THminus,THplus,
     &        Etotal(3)
      INTEGER iDetSpe(L1DETSPElen),              ! detector specifieres array
     &        jCaloInf,jCaloGeo,jCellGeo,
     &        iHits(L1HITlen,1)
      REAL    rHits(L1HITlen,1)
      EQUIVALENCE (iHits,rHits)
c
      INTEGER MaxNmoduleX,MaxNmoduleY
      PARAMETER (MaxNmoduleX=60)
      PARAMETER (MaxNmoduleY=50)
      INTEGER iModule(-MaxNmoduleX/2:MaxNmoduleX/2, !Modules matrix
     &                        -MaxNmoduleY/2:MaxNmoduleY)
      INTEGER iXplus,iXminus,iYplus,iYminus,nBorder
      PARAMETER (iXplus = 1)
      PARAMETER (iXminus = 2)
      PARAMETER (iYplus = 4)
      PARAMETER (iYminus = 8)
      PARAMETER (nBorder = 8)      ! number of searched neighbous
      REAL    dxBorder(nBorder),dyBorder(nBorder),Enei(nBorder)
      INTEGER iNeiDet(nBorder)
c
      REAL CellGeo(L1GEOINFlen),COGGeo(L1GEOINFlen)
c
      INTEGER MaxCellNo
      PARAMETER (MaxCellNo=6000)
      INTEGER iCellInfo(0:nBorder,MaxCellNo)	! Cell packed information
c
      CHARACTER*4 CaloName
c
      LOGICAL initialized
c
      SAVE initialized,nCellTotal,iCellInfo,iModule
c
      REAL VMAX
c
      INTEGER IntFromReal
      REAL r
c
      DATA dxBorder /-1., 0., 1., 1., 1., 0.,-1.,-1./
      DATA dyBorder / 1., 1., 1., 0.,-1.,-1.,-1., 0./
      DATA iNeiDet  /  0,  4,  0,  1,  0,  8,  0,  2/
      DATA      initialized/.false./
      DATA CaloName /'CALW'/
c
      IntFromReal(r)=INT(r+1000.)-1000

#include "l1si/l1mesdf.ff"
c
c   CellInfo packing:
c   bits [1-14]          Section (module) number
c   bits [15-17]         iX cell number inside module
c   bits [18-20]         iY cell number inside module
c   bits [21-23]         ndim (division ndim*ndim)
c   bits [24-28]         free
c   bits [29-32]         for neighbouses: position with respect to central
c
      IF (L1PARprnlev.ge.1) THEN
         WRITE (L1LUNprn,998)
 998     FORMAT(1x,'L1PREEF==> BEGIN ',58('#'))
      END IF
c
      ierr = 0   ! no errors (so far)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Do initialization here
c
      IF (.not.initialized) THEN
c
       igeneral = 1
c
c      Looking for calorimeter
c
       CALL UCTOH(CaloName,iECAL,4,4)
       iDetKAL = l1detsl(iECAL)
       IF ( iDetKAL.LE.0) THEN  ! detector KALi not existing
        ierr = 1
        RETURN
       END IF
c
c      BASE_SIZE determination
c
       iDetSpe(L1DETSPEdet) = iDetKAL
       iDetSpe(L1DETSPElayer) = 1
       iDetSpe(L1DETSPEsection) = 1
       CALL l1detif(iDetSpe,jCaloGeo,jCaloInf,jCellGeo)
       BASE_SIZE = Q(jCaloGeo+L1GEOINFsx)
c
       CALL VZERO(iModule(-MaxNmoduleX/2,-MaxNmoduleY/2),
     &      MaxNmoduleX*MaxNmoduleY) ! initiate matrix
       CALL VZERO(iCellInfo(0,1),(1+nBorder)*MaxCellNo) ! initiate cell info base
c
c     calorimeters
c
       nsec = IQ(jCaloInf+L1DETINFnsec)
       DO isec=1,nsec
        iDetSpe(L1DETSPEsection) = isec
        CALL l1detif(iDetSpe,jCaloGeo,jCaloInf,jCellGeo)
        iX = IntFromReal((Q(jCaloGeo+L1GEOINFx0)+
     &       0.5*Q(jCaloGeo+L1GEOINFsx))/BASE_SIZE) !X position
        iY = IntFromReal((Q(jCaloGeo+L1GEOINFy0)+
     &       0.5*Q(jCaloGeo+L1GEOINFsy))/BASE_SIZE) !Y position
        ndim = IQ(jCaloInf+L1DETINFnRow)
        CELL_SIZE = BASE_SIZE/ndim
        iModule(iX,iY) = igeneral
c
c           The cell initiation
c
        DO iXCell=1,ndim
         X0Cell = Q(jCaloGeo+L1GEOINFx0)+
     &        (FLOAT(iXCell)-0.5)*CELL_SIZE
         DO iYCell=1,ndim
          Y0Cell = Q(jCaloGeo+L1GEOINFy0)+
     &         (FLOAT(iXCell)-0.5)*CELL_SIZE
c
c             Pack information
c
          CALL SBYT(isec,iInfo,1,14)
          CALL SBYT(iXcell,iInfo,15,3)
          CALL SBYT(iYcell,iInfo,18,3)
          CALL SBYT(ndim,iInfo,21,3)
          iCellInfo(0,igeneral)=iInfo
          igeneral = igeneral+1
         ENDDO
        ENDDO
       ENDDO
       nCellTotal = igeneral-1  ! Total number of celles
c
c      Loop over all modules: neighbous initiation
c
       DO iModuleX=-MaxNmoduleX/2,MaxNmoduleX/2
        DO iModuleY=-MaxNmoduleY/2,MaxNmoduleY/2 ! look for neghbous
         igeneral = iModule(iModuleX,iModuleY)
         IF (igeneral.NE.0)		THEN ! initiated cell
          ndim0 = JBYT(iCellInfo(0,igeneral),21,3)
          iCalo0 = ndim0
          IF(iCalo0.GT.2)		iCalo0 = 3 !define calo
                                                   !number (1,2,3)
          iCardX0 = IntFromReal(FLOAT(iModuleX+
     &         L1DEFcardXshift(iCalo0))/FLOAT(L1DEFcardXsize(iCalo0)))
          iCardY0 = IntFromReal(FLOAT(iModuleY+
     &         L1DEFcardYshift(iCalo0))/FLOAT(L1DEFcardYsize(iCalo0)))
          DO icell=1,ndim0*ndim0
           iInfo = iCellInfo(0,igeneral)
           iXCell0 = JBYT(iInfo,15,3)
           iYCell0 = JBYT(iInfo,18,3)
           X0Clust = iModuleX+(FLOAT(iXcell0)-0.5)/ndim0
           Y0Clust = iModuleY+(FLOAT(iYcell0)-0.5)/ndim0
           nNeigh = 0
           DO iborder=1,nBorder
            iCellInfo(iborder,igeneral) = 0
            rX = X0Clust+dxBorder(iborder)/ndim0
            rY = Y0Clust+dyBorder(iborder)/ndim0
            iXborder = IntFromReal(rX)
            iYborder = IntFromReal(rY)
            igenNei = iModule(iXborder,iYborder) ! first cell in Nei module
            iCardX = IntFromReal((rX+L1DEFcardXshift(iCalo0))/
     &           FLOAT(L1DEFcardXsize(iCalo0)))
            iCardY = IntFromReal((rY+L1DEFcardYshift(iCalo0))/
     &           FLOAT(L1DEFcardYsize(iCalo0)))
            IF(iCardX.NE.iCardX0)   THEN
             IF(iCardX.GT.iCardX0)   THEN
              ioverlap = -L1DEFcardOvlp
             ELSE
              ioverlap = L1DEFcardOvlp
             ENDIF
             iCardX = IntFromReal((rX+L1DEFcardXshift(iCalo0)+
     &            ioverlap)/FLOAT(L1DEFcardXsize(iCalo0)))
             IF(iCardX.NE.iCardX0) GOTO 100 ! different cards:skip
            ENDIF
            IF(iCardY.NE.iCardY0)    THEN
             IF(iCardY.GT.iCardY0)   THEN
              ioverlap = -L1DEFcardOvlp
             ELSE
              ioverlap = L1DEFcardOvlp
             ENDIF
             iCardY = IntFromReal((rY+L1DEFcardYshift(iCalo0)+
     &            ioverlap)/FLOAT(L1DEFcardYsize(iCalo0)))
             IF(iCardY.NE.iCardY0) GOTO 100 ! different cards:skip
            ENDIF
            IF(igenNei.EQ.0)         GOTO 100 ! noninitiated module: skip
            neiDet = iNeiDet(iborder)
            iNeiInfo = iCellInfo(0,igenNei)
            ndim = JBYT(iNeiInfo,21,3)
            IF(ndim.NE.ndim0)        GOTO 100 ! different ECALs: skip
            iXcell = ndim*(rX-FLOAT(iXborder))+1
            iYcell = ndim*(rY-FLOAT(iYborder))+1
            iNeiInfo = iCellInfo(0,igenNei+
     &           ndim*(iXcell-1)+(iYcell-1)) ! shift to interesting cell
            CALL SBYT(neiDet,iNeiInfo,29,4) ! set geo status
            iCellInfo(iborder,igeneral) = iNeiInfo
            goto 101
 100        CONTINUE
c           print '(''L1PREEF_SKIP=>'',8i4)',
c           &                  iCalo0,iModuleX,iModuleY,
c           &                  icell,iCardX0,iCardY0,iCardX,iCardY
 101        continue
           ENDDO
           igeneral = igeneral+1
c          PRINT '(6i8)',
c          &               iModuleX,iModuleY,ndim,icell,nNeigh,igeneral
          ENDDO
         ENDIF
        ENDDO
       ENDDO
       initialized = .TRUE.
       PRINT *,'L1PREEF==> end of initialization'
      ENDIF
c
c     Run part begin here...
c
      CALL VZERO(Etotal(1),3)   ! clear total deposited energy
      DO igeneral=1,nCellTotal
       iInfo = iCellInfo(0,igeneral)
       iDetSpe(L1DETSPEdet) = iDetKAL
       iDetSpe(L1DETSPElayer) = 1
       isec = JBYT(iInfo,1,14)
       iDetSpe(L1DETSPEsection) = isec
       iXCell0 = JBYT(iInfo,15,3)
       iYCell0 = JBYT(iInfo,18,3)
       CALL L1HIGET(iP,isec,1,L1RUNcuBX,(iXCell0-1)*ndim+iYCell0,1
     $      ,iHits)
       IF(iHits(L1HITnpo,1).GT.0)   THEN !hit exists
c       PRINT '(''central'',3i5,2f9.2,f10.4)',
c     &          iDetSpe(L1DETSPEsection),
c     &          iXCell0,iYCell0,x0clust,y0clust,E0
       E0 = rHits(L1HITvalue,1)
       ndim   = JBYT(iInfo,21,3)
       iCalo0 = ndim
       IF(iCalo0.GT.2)  iCalo0 = 3 ! Central cell type
        Etotal(iCalo0) = Etotal(iCalo0)+E0 ! add energy to the total one
        CALL l1detif(iDetSpe,jCaloGeo,jCaloInf,jCellGeo)
        CellGeo(L1GEOINFx0) = Q(jCaloGeo+L1GEOINFx0)+
     &       Q(jCellGeo+L1GEOINFsx)*(iXCell0-1)
        CellGeo(L1GEOINFy0) = Q(jCaloGeo+L1GEOINFy0)+
     &       Q(jCellGeo+L1GEOINFsy)*(iYCell0-1)
        CellGeo(L1GEOINFsx) = Q(jCellGeo+L1GEOINFsx)
        CellGeo(L1GEOINFsy) = Q(jCellGeo+L1GEOINFsy)
        CellGeo(L1GEOINFz) = Q(jCaloGeo+L1GEOINFz)
        X0Clust = CellGeo(L1GEOINFx0)+0.5*CellGeo(L1GEOINFsx)
        Y0Clust = CellGeo(L1GEOINFy0)+0.5*CellGeo(L1GEOINFsy)
        iCardX0 = IntFromReal((X0Clust/BASE_SIZE+
     &       L1DEFcardXshift(iCalo0))/FLOAT(L1DEFcardXsize(iCalo0)))
        iCardY0 = IntFromReal((Y0Clust/BASE_SIZE+
     &       L1DEFcardYshift(iCalo0))/FLOAT(L1DEFcardYsize(iCalo0)))
c
c       Check central cell pretrigger condition
c
        CUT = E0/T1ECACU(X0Clust,Y0Clust) ! thresh. func. value
c
        IF (CUT.lt.0.5)   GOTO 250 ! less then 1/2 of threshould: SKIP!
c
        IF (L1PARprnlev.ge.1) THEN
         WRITE (L1LUNprn,
     &        '(1x,''L1PREEF==> E0/CUT/x/y:'',4f9.3)')
     &        E0,CUT,X0Clust,Y0Clust
        ENDIF
        iHitPoi = iHits(L1HITpos,1) ! reference on track banks
        Eclu = 0.
        Explus = 0.
        Exminus = 0.
        Eyplus = 0.
        Eyminus = 0.
        nNeigh = 0
        DO iNei=1,nBorder
         IF(iCellInfo(iNei,igeneral).NE.0)	THEN ! neighbous exists
          nNeigh = nNeigh+1
          iInfo = iCellInfo(iNei,igeneral)
          isec = JBYT(iInfo,1,14)
          iXCell = JBYT(iInfo,15,3)
          iYCell = JBYT(iInfo,18,3)
          ndim   = JBYT(iInfo,21,3)
          neiDet = JBYT(iInfo,29,4)
          CALL L1HIGET(iP,isec,1,L1RUNcuBX,
     &         (iXCell-1)*ndim+iYCell,1,iHits)
c         PRINT *,'       ',iDetSpe(L1DETSPEsection),iXCell,iYCell,
c         &         rHits(L1HITvalue,1)
          IF(iHits(L1HITnpo,1).GT.0)    THEN !hit exists
           Enei(iNei) = rHits(L1HITvalue,1)
           Eclu = Eclu+Enei(iNei)
           IF(neiDet.EQ.iXplus)   THEN
            Explus = Explus+Enei(iNei)
           ELSEIF(neiDet.EQ.iXminus)   THEN
            Exminus = Exminus+Enei(iNei)
           ELSEIF(neiDet.EQ.iYplus)   THEN
            Eyplus = Eyplus+Enei(iNei)
           ELSEIF(neiDet.EQ.iYminus)   THEN
            Eyminus = Eyminus+Enei(iNei)
           ENDIF
          ELSE
           Enei(iNei) = 0.      ! Cell exists without hit
          ENDIF
         ELSE
          Enei(iNei) = -1.E-6   !No cell...
         ENDIF
        ENDDO
        IF (L1PARprnlev.ge.1) THEN
         WRITE (L1LUNprn,
     &        '(1x,''L1PREEF==> E0,Eneigh:'',2f7.2,i3,8(f7.3))')
     &        E0,Eclu,nNeigh,(Enei(iNei),iNei=1,nBorder)

        ENDIF
c
c       calculate "COG improvement"
c
        IF(VMAX(Enei,nBorder).GT.E0)  GOTO 250 !Central is not the largest:SKIP
c
        CALL L1COG(iCalo0,CellGeo,E0,nBorder,Enei,COGGeo,Ecog)

c
c       Check pretrigger conditions
c
        CUT = Ecog/T1ECACU(X0Clust,Y0Clust) ! thresh. func. value
c
        IF (CUT.gt.1.) THEN     ! accept ?
         IF (L1PARprnlev.ge.1) THEN
          WRITE (L1LUNprn,
     &         '(1x,''L1PREEF==> Ecog/CUT/x/y:'',4f9.3)')
     &         Ecog,CUT,X0Clust,Y0Clust
         ENDIF
         CALL l1mesne(L1RUNcuBX,MessPo) ! get new message
         IF ( MessPo.le.0 ) THEN ! message storage exceeded
          ierr = 1
          RETURN
         END IF

c
c        -----     looking for bremsstrahlung clusters
c
         T1MEstor(MessPo+L1MEbremPlus) = 0. ! No brems so far
         T1MEstor(MessPo+L1MEbremMinus) = 0.
         CALL L1KINPO(0.,0.,Ecog,0.,0.,0.,CellGeo(L1GEOINFz),
     &        dxBrem,dyBrem)    ! distance to brem
         IF(dxBrem.GT.-10000)   THEN !reasonable track
          DO icharge=-1,1,2
           Ebrem = 0.
           xBrem = (X0Clust+icharge*dxBrem)/BASE_SIZE
           yBrem = Y0Clust/BASE_SIZE
           iXbrem = IntFromReal(xBrem)
           iYbrem = IntFromReal(yBrem)
           IF(ABS(iXbrem).GT.MaxNmoduleX/2.OR.
     &          ABS(iYbrem).GT.MaxNmoduleY/2)  GOTO 200 !outside
                                !calorimeter: skip
           igbrem = iModule(iXbrem,iYbrem)
           IF (igbrem.EQ.0)   GOTO 200 ! noninitiated module:skip
           iCardX = IntFromReal((xBrem+L1DEFcardXshift(iCalo0))/
     &          FLOAT(L1DEFcardXsize(iCalo0)))
           iCardY = IntFromReal((yBrem+L1DEFcardYshift(iCalo0))/
     &          FLOAT(L1DEFcardYsize(iCalo0)))
           IF(ABS(iCardX-iCardX0).GT.L1DEFbremDiff(iCalo0))
     &          GOTO 200        ! brem is too far: skip
           ndim = JBYT(iCellInfo(0,igbrem),21,3)
           iXcell = ndim*(xBrem-FLOAT(iXbrem))+1
           iYcell = ndim*(yBrem-FLOAT(iYbrem))+1
           igbrem = igbrem+ndim*(iXcell-1)+(iYcell-1)
           iInfo = iCellInfo(0,igbrem) ! shift to interesting cell
           isec = JBYT(iInfo,1,14)
           Ebrem = 0.
           DO iNeiBrem=0,nBorder
            IF(iCellInfo(iNeiBrem,igbrem).NE.0) THEN ! existing neighbous
             iInfo = JBYT(iCellInfo(iNeiBrem,igbrem),1,28)
             DO iNei=0,nBorder  ! compare with cluster
              IF(iInfo.EQ.JBYT(iCellInfo(iNei,igeneral),1,28))  THEN
                                !avoid doble counting: skip this cell
               GOTO 112
              ENDIF
             ENDDO
             isec = JBYT(iInfo,1,14)
             iXCell = JBYT(iInfo,15,3)
             iYCell = JBYT(iInfo,18,3)
             ndim   = JBYT(iInfo,21,3)
             CALL L1HIGET(iP,isec,1,L1RUNcuBX,
     &            (iXCell-1)*ndim+iYCell,1,iHits)
             IF(iHits(L1HITnpo,1).GT.0)    THEN !hit exists
              Ebrem = Ebrem+rHits(L1HITvalue,1)
             ENDIF
 112         CONTINUE
            ENDIF
           ENDDO
           IF(icharge.EQ.1)   THEN
            T1MEstor(MessPo+L1MEbremPlus) = Ebrem
            T1MEstor(MessPo+L1MEbremPlusTh) =
     &           Ebrem/T1ECACU(xBrem,yBrem)
           ELSE
            T1MEstor(MessPo+L1MEbremMinus) = Ebrem
            T1MEstor(MessPo+L1MEbremMinusTh) =
     &           Ebrem/T1ECACU(xBrem,yBrem)
           ENDIF
 200       CONTINUE
          ENDDO
         ENDIF
         IF (L1PARprnlev.ge.1) THEN
          PRINT '('' L1PREEF==> dxbrem/E+/E-:'',3f10.3)',dxbrem
     $         ,T1MEstor(MessPo+L1MEbremPlus)
     &         ,T1MEstor(MessPo+L1MEbremMinus)
         ENDIF
c
         iTime = L1RUNcutime+L1DEFcaltim ! time after Pretrigger
c
c        --- Coordinate information
c
         iPoPo = MessPo+L1MEpoint(0)+L1POreg
         iPoCog = MessPO+L1POlcog ! Put COG to COG
         CALL UCOPY(COGGeo(1),T1MEstor(iPoPo+1),L1GEOINFlen) ! Put COG to reg
         CALL UCOPY(COGGeo(1),T1MEstor(iPoCog+1),L1GEOINFlen) ! Put COG to reg
c        --- MC matching
         CALL L1ECAPO(MessPo,itrk,xPo,yPo,zPo)
         IF (L1PARprnlev.ge.1) THEN
          PRINT '('' L1PREEF==> E0,Ex+,Ex-,Ey+,Ey-:'',5f8.2)',
     &         E0,Explus,Exminus,Eyplus,Eyminus
          xCo = T1MEstor(iPoCog+L1GEOINFx0)+
     &         T1MEstor(iPoCog+L1GEOINFsx)*0.5
          yCo = T1MEstor(iPoCog+L1GEOINFy0)+
     &         T1MEstor(iPoCog+L1GEOINFsy)*0.5
          PRINT '('' L1PREEF==> COG x,y,E,dx/sx,dy/sy:'',5f8.2)',
     &         xCo,yCo,Ecog,
     &         ABS(xCo-xPo)/T1MEstor(iPoCog+L1GEOINFsx),
     &         ABS(yCo-yPo)/T1MEstor(iPoCog+L1GEOINFsy)
         ENDIF
c        --- set flags
         L1MEstor(MessPo+L1MElast)    = 0 ! last point was pretrigger
         L1MEstor(MessPo+L1MEcreated) = 0 ! first point was pretrigger
         L1MEstor(MessPo+L1MEnextPC)  = iP ! set active proc.
         L1MEstor(MessPo+L1MEactive)  = L1MEacPRE ! last processed
c        --- fill user parameters
         L1MEstor(MessPo+L1MEuser1) = iCalo0
         L1MEstor(MessPo+L1MEuser2) = nNeigh
c        --- fill soft message
         L1MEstor(MessPo+L1MEprid) = L1PREelec
         L1MEstor(MessPo+L1MEprbx) = L1RUNcuBX
         T1MEstor(MessPo+L1MEpren) = Ecog
         T1MEstor(MessPo+L1MEprth) = CUT ! store only KTrig dependent part of cut
         T1MEstor(MessPo+L1MEpreth)= T1ECACU(X0Clust,Y0Clust)
c
         iPRE = L1PCstor(iP+L1PCnum) ! pretrigger number
         iPoPo = L1MEpoint(0)+MessPo
         L1MEstor(iPoPo+L1POpcpo) = iP
         L1MEstor(iPoPo+L1POtrkn) = 0
         L1MEstor(iPoPo+L1POtrk0) = iHitPoi ! reference on track bank
         L1MEstor(iPoPo+L1POtrkp) = 0
         L1MEstor(iPoPo+L1POsup)  = L1DEFpredef(L1PREsl,iPRE)
         L1MEstor(iPoPo+L1POtime) = iTime
         iPOPO = iPOPO+L1POreg
c
c....fill hard message
c
         L1MEstor(MessPo+L1HAprbx)  = L1RUNcuBX
         L1MEstor(MessPo+L1HAprid)  = L1PREelec
         T1MEstor(MessPo+L1HApren)  = Ecog
         T1MEstor(MessPo+L1HAtxi)  =
     &        T1MEstor(iPoPo+L1GEOINFx0)+T1MEstor(iPoPo+L1GEOINFsx)
         T1MEstor(MessPo+L1HAteta)  =
     &        T1MEstor(iPoPo+L1GEOINFy0)+0.5*T1MEstor(iPoPo+L1GEOINFsy)

         T1MEstor(MessPo+L1HAEbrp) = T1MEstor(MessPo+L1MEbremPlus)
         T1MEstor(MessPo+L1HAEbrm) = T1MEstor(MessPo+L1MEbremMinus)
         T1MEstor(MessPo+L1HAwidt) = T1MEstor(iPoPo+L1GEOINFsx)
         L1MEstor(MessPo+L1HAgall) = 0
c
c
c..... calculate photon trigger flag for accepted clusters
c
        L1MEstor(MessPo+L1HAgama)=
     &            L1GAMCU(Ecog, T1MEstor(MessPo+L1HAtxi)
     &                        +0.5*T1MEstor(iPoPo+L1GEOINFsx),
     &           T1MEstor(MessPo+L1HAteta),T1MEstor(iPoPo+L1GEOINFz),
     &           T1DEFgamath)

        IF ( L1PARprnlev.gt.1 ) then
         WRITE(L1LUNprn,*)'L1PREEF==> before L1MESUP: x/sx/y/sy/z:',
     &    T1MEstor(iPoPo+L1GEOINFx0),T1MEstor(iPoPo+L1GEOINFsx),
     &    T1MEstor(iPoPo+L1GEOINFy0),T1MEstor(iPoPo+L1GEOINFsy),
     &    T1MEstor(iPoPo+L1GEOINFz )
        ENDIF
c
c.....  update message (get ROI(s))
c
         CALL l1mesup(MessPo,iTime,ierr)
         IF ( ierr.ge.2 ) RETURN ! fatal error
         IF ( ierr.eq.1 ) THEN
          IF ( L1PARprnlev.gt.0 )
     &         WRITE(L1LUNprn,*) 'L1PREEF==> Connection error'
          CALL l1mesde(MessPO,L1MEDEnoscr) ! delete message, do not drop data
c
          ierr = 0
         ELSE
c
c.... fill hardware ROI after update.
c
         ipo1 = messpo+L1ROIreg+L1MEroi(L1MEstor(messpo+L1melast))
         CALL  T1HAdxi(T1MEstor(iPoPo+L1GEOINFx0),
     &                T1MEstor(iPoPo+L1GEOINFsx),
     &                T1MEstor(iPoPo+L1GEOINFz),
     &                T1MEstor(iPo1+L1GEOINFx0),
     &                T1MEstor(iPo1+L1GEOINFsx),
     &                T1MEstor(iPo1+L1GEOINFz),dxi,ddxi)
c
          L1MEstor(MessPo+L1HAdest)=L1MEstor(MessPo+L1MEnextPC)
          T1MEstor(MessPo+L1HAtdxi)=dxi
          T1MEstor(MessPo+L1HAddxi)=ddxi
          L1MEstor(MessPo+L1HAtnxi)=0
c
c.. if L1mesup found 2 ROI, fill here the second message
c
          ipo2 = L1MEstor(MessPo + L1menext)
        IF(ipo2.gt.0) then
         ipo3 =  ipo2+L1ROIreg+L1MEroi(L1MEstor(ipo2+l1melast))
         call T1HAdxi( T1MEstor(iPoPo+L1GEOINFx0),
     &                 T1MEstor(iPoPo+L1GEOINFsx),
     &                 T1MEstor(iPoPo+L1GEOINFz),
     &                 T1MEstor(iPo3+L1GEOINFx0),
     &                 T1MEstor(iPo3+L1GEOINFsx),
     &                 T1MEstor(iPo3+L1GEOINFz),dxi,ddxi)
c
          L1MEstor(iPo2+L1HAdest)=L1MEstor(iPo2+L1MEnextPC)
          T1MEstor(iPo2+L1HAtdxi)=dxi
          T1MEstor(iPo2+L1HAddxi)=ddxi
          L1MEstor(iPo2+L1HAtnxi)=0
        ENDIF
c
          CALL l1jobsb(MessPo,iTime,JobPo) ! submitt job
          IF ( JobPo.le.0 ) THEN
           CALL l1mesde(MessPo,L1MEDEnoscr)
          ELSE
           CALL l1usrpr(MessPo,cut,Ecog,Explus,
     &          Exminus,Eyplus,Eyminus)
          ENDIF
         END IF
        END IF                  ! hit accepted
       ENDIF                    ! hit exists
 250   CONTINUE
      ENDDO                     ! over celles
c
      CALL L1USRSA('E_INNER',Etotal(3),L1RUNcuBX) ! Store inner CALO energy
c
      IF (L1PARprnlev.ge.1) THEN
       WRITE (L1LUNprn,999)
 999   FORMAT(1x,'L1PREEF==> END ',60('#'))
      ENDIF
c
      RETURN
c
      END










