*CMZ :  1.01/00 08/11/95  17.35.44  by  Fedor Ratnikov
*CMZ :  1.00/01 16/08/95  14.50.15  by   Ivan Belyaev
*CMZ :  0.01/02 12/08/94  19.28.57  by  Dominik Ressing
*CMZ :  0.01/01 25/07/94  15.06.32  by  Dominik Ressing
*-- Author :    Dominik Ressing   24/07/94
************************************************************************
*
* L1PREFA
* written by Dominik Ressing, 24/07/94 16.23.08
*
* This routines action:
* Performes fast simulation of the pretriggers for the
* current BX L1RUNcuBX
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* iPre        in          number of pretrigger
* ierr        out         set to <>0 on error
*
*
************************************************************************
c
      SUBROUTINE L1PREFA(iPre,ierr)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1prcdf.fi"
c
      INTEGER ierr,iPre,iPrPo,Num
#include "l1si/l1prcdf.ff"
c
      iPrPo = L1PCprep(iPre)                            ! pointer to proc definitions
      IF ( L1PCstor(iPrPo+L1PCtype).ne.L1PCtpre ) THEN  ! is this really a pretrigger?
         ierr = -1
         RETURN
      END IF
c
      Num = L1PCstor(iPrPo+L1PCnum)      ! number as in l1simu.dat
      IF ( L1PARhandev.ge.2 ) THEN
         IF ( L1DEFpredef(L1PREkind,num).eq.L1PREtest ) THEN
            CALL l1pretr(iPrPo,ierr)   ! generate Test pretriggers
         END IF
      ELSE
c
       IF ( L1DEFpredef(L1PREkind,num).eq.L1PREelec ) THEN
        CALL l1preef(iPrPo,ierr) ! generate ECAL pretriggers
       ELSEIF( L1DEFpredef(L1PREkind,num).eq.L1PREpipi ) THEN
        CALL l1prehf(iPrPo,ierr) ! generate P.Pakhlov pretriggers
       ELSE IF ( L1DEFpredef(L1PREkind,num).eq.L1PREmuon) THEN
        CALL l1premf(iPrPo,ierr) ! generate MUON Pretriggers
       ELSE IF ( L1DEFpredef(L1PREkind,num).eq.L1PREpxmuon) THEN
        CALL l1prxmf(iPrPo,ierr) ! generate MUON pixel Pretriggers
       END IF
      END IF
c
      RETURN
      END









