*CMZ :          04/09/96  20.20.09  by  Fedor Ratnikov
*CMZ :  1.00/06 28/09/95  18.29.31  by   Ivan Belyaev
*CMZ :  1.00/04 17/09/95  21.35.42  by   Ivan Belyaev
*CMZ :  1.00/01 23/07/95  19.21.22  by  Fedor Ratnikov
*CMZ :   . 1/03 24/07/94  14.16.43  by  Dominik Ressing
*-- Author :    Dominik Ressing   24/07/94
************************************************************************
*
* L1USREV
* written by Dominik Ressing, 24/07/94 14.15.15
*
* This routines action:
* User routine called at the end of the processing for one event.
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* iBX        in           number of the BunchCrossing which was processed
*
*
************************************************************************
c
      SUBROUTINE L1USREV(iBX)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1user.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1clink.fi"
#include "l1si/rclink.fi"
#include "l1si/rchead.fi"
#include "l1si/rcfdef.fi"
#include "l1si/l1banks.fi"
#include "arte/Arte.fi"
c
      INTEGER IQUEST
      COMMON/QUEST/IQUEST(100)
c
      INTEGER iBX,ievtw,ievtco, iPartTypes
      INTEGER Itrk,Ntrk,Jpo,iver,ier
      REAL P,E,x,y,Pa,T1ECACU
      EXTERNAL T1ECACU
      LOGICAL HEXIST
      DATA ievtw /0/, ievtco /0/
c
#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"
c
      L1USRallEvents = L1USRallEvents + 1
      ievtco = ievtco + 1
      IF(L1PARwrite)    THEN
         IF(L1EVMAXNpairs(iBX).GT.0)   THEN ! write event
            ievtw = ievtw+1
            L1USRfltEvents = L1USRfltEvents + 1
            WRITE(L1LUNprn,900) ievtw,ievtco,float(ievtw)/float(ievtco)
 900        FORMAT('L1USREV==> event (pseudo)written:',i6,
     &                        ' total events ',i6,
     &                        ' ratio = ',f6.4)
         ENDIF
      ENDIF
c
      IF(HEXIST(L1EVTTUPnr))   THEN
         T1EVTTUMass   = T1EVMAXMass(iBX)
         T1EVTTUPtSe   = T1EVMAXPtSe(iBX)
         T1EVTTUPtSm   = T1EVMAXPtSm(iBX)
         T1EVTTUPtUee  = T1EVMAXPtUee(iBX)
         T1EVTTUPtee   = T1EVMAXPtee(iBX)
         T1EVTTUPtUmm  = T1EVMAXPtUmm(iBX)
         T1EVTTUFbrems = T1EVMAXFbrems(iBX)
         L1EVTTUNmess  = L1EVMAXNmess(iBX)
         L1EVTTUNtpm   = L1EVMAXNtpm(iBX)
         L1EVTTUNpairs = L1EVMAXNpairs(iBX)
         L1EVTTUiBX    = iRCEvent
         L1EVTTUnInt   = nRCIntTot
         T1EVTUEinner  = T1EVEinner(iBX)
         DO iPartTypes = 1 , L1PARNPartTypes
          T1EVTTUMaxPtValues( iPartTypes ) =
     &     T1EVMaxPtValues(   iPartTypes , iBX )
         ENDDO
c
         CALL HFNT(L1EVTTUPnr)
c
         T1EVMAXMass(iBX)   = 0.
         T1EVMAXPtSe(iBX)   = 0.
         T1EVMAXPtSm(iBX)   = 0.
         T1EVMAXPtUee(iBX)  = 0.
         T1EVMAXPtee(iBX)   = 0.
         T1EVMAXPtUmm(iBX)  = 0.
         T1EVMAXFbrems(iBX) = 0.
         L1EVMAXnpairs(iBX) = 0
         L1EVMAXNmess(iBX)  = 0
         L1EVMAXNtpm(iBX)   = 0
         DO iPartTypes = 1 , L1PARNPartTypes
          T1EVMaxPtValues(   iPartTypes , iBX ) = 0
         ENDDO
      ENDIF
c
c     --- fill tracks N-Tuple:
c
c
      IF(HEXIST(L1TRKTUPnr))    THEN
         Ntrk = N_U(JMTRA)
c
         Ntrk = MIN(Ntrk,1000)
         DO itrk=1,Ntrk
c
            P = F_V(1,itrk,JMTRA)**2+
     &           F_V(2,itrk,JMTRA)**2+
     &           F_V(3,itrk,JMTRA)**2
            E = SQRT(P + F_V(4,itrk,JMTRA)**2)
            P = SQRT(P)
c
            CALL l1getrx(itrk,Jpo)
c
            T1TRKTUE  = E
            T1TRKTUPx = F_V(1,itrk,JMTRA)
            T1TRKTUPy = F_V(2,itrk,JMTRA)
            T1TRKTUPz = F_V(3,itrk,JMTRA)
            L1TRKTUID = I_V(6,itrk,JMTRA)
            L1TRKTUiBX  = iRCEvent
            L1TRKTUiTrk = itrk
            Iver = I_V(7,itrk,JMTRA)
            IF ( Iver.le.0 .or. Iver.gt.N_U(JMVER) ) THEN
               T1TRKTUVx = 0.
               T1TRKTUVy = 0.
               T1TRKTUVz = -9.99
            ELSE
               T1TRKTUVx = F_V(1,Iver,JMVER)
               T1TRKTUVy = F_V(2,Iver,JMVER)
               T1TRKTUVz = F_V(3,Iver,JMVER)
            END IF
c
            IF ( T1TRKTUVz.gt.1300. .and. T1TRKTUVz.lt.1450 ) GO TO 444 ! skip in ECAL
c
            IF ( Jpo.le.0 ) THEN
               T1TRKTUDiffMe = -1.
               L1TRKTUiFlag  = -1
               T1TRKTUPafter = 0.
               T1TRKTUKtrig  = 0.
            ELSE
               IF ( Q(Jpo+L1_TRK_DIFF).ge.0. ) THEN
                  T1TRKTUDiffMe = SQRT(Q(Jpo+L1_TRK_DIFF))
               ELSE
                  T1TRKTUDiffMe = 10.
               END IF
               CALL l1getrp(iTrk,T1ZECADF,x,y,Pa)
               L1TRKTUiFlag  = IQ(Jpo+L1_TRK_FLAG)
               T1TRKTUPafter = Pa
               T1TRKTUKtrig  = E/T1ECACU(x,y)*T1DEFktrig ! reached value of KTrig
               T1TRKTUKtrig  = MIN(T1TRKTUKtrig,5000.)
            END IF
c
            CALL HFNT(L1TRKTUPnr)
 444        CONTINUE
c
         END DO
      ENDIF
c
      RETURN
c
      END
