*CMZ :  1.00/01 28/03/95  00.27.35  by  Fedor Ratnikov
*CMZ :   . 1/03 24/07/94  13.29.33  by  Dominik Ressing
*-- Author :    Dominik Ressing   24/07/94
************************************************************************
*
* L1USREX
* written by Dominik Ressing, 24/07/94 13.17.22
*
* This routines action:
* User routine called before calling the execution routine for the
* topmost job in the stack
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* JobPointer  in          pointer to next-to-execute job
*
*
************************************************************************
c
      SUBROUTINE L1USREX(JobPointer)
c
      IMPLICIT NONE
#include "gean/gcbank.fi"
#include "l1si/rchead.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1jobdf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1prcdf.fi"
#include "l1si/l1user.fi"
c
      INTEGER JobPointer
c
      INTEGER MePo,iTFU,iPcPo,incr,iPoi2,iproPo,ilast,iROI
      LOGICAL HEXIST
#include "l1si/l1mesdf.ff"
c
      L1TFUTUibx = iRCEvent
c
      MePo  = L1JOBstore(JobPointer+L1JOBmess)        ! points to message of this job
      L1TFUTUpretype = L1MEstor(MePo+L1MEprid)        ! pretrigger type
      ilast = L1MEstor(MePo+L1MEactive)               ! last processor type
      IF(ilast.eq.L1MEacTFU.or.ilast.eq.L1MEacPRE)    THEN      ! last processor of interest here?
         iPcPo = L1MEstor(MePo+L1MEnextPC) ! points to destination processor of this job
c
         IF(L1PCstor(iPcPo+L1PCtype).eq.L1PCttfu) THEN
            iTFU = L1PCstor(iPcPo+L1PCnum) ! get TFU num
            L1TFUTUtoSUP = L1DEFtfudef(L1TFUsup,iTFU) ! superlayer number
            IF (L1TFUTUtoSUP.eq.1) THEN
               incr = 2
            ELSE
               incr = 1
            END IF
            L1TFUTUtoTFU = MOD(iTFU-incr,15)+1 ! form TFU-id within superlayer
         ELSE
            L1TFUTUtoSUP = 0
            L1TFUTUtoTFU = 0
         END IF
c
         iPoi2 = MePo + L1MEpoint(L1MEstor(MePo+L1MElast)) ! pointer to point
         T1TFUTUx0poi = T1MEstor(iPoi2+L1POreg+L1GEOINFx0)  ! point geometry
         T1TFUTUsxpoi = T1MEstor(iPoi2+L1POreg+L1GEOINFsx)
         T1TFUTUy0poi = T1MEstor(iPoi2+L1POreg+L1GEOINFy0)
         T1TFUTUsypoi = T1MEstor(iPoi2+L1POreg+L1GEOINFsy)
         iROI = MePo+L1MEroi(L1MEstor(MePo+L1MElast))  ! pointer to ROI
         T1TFUTUx0ROI = T1MEstor(iROI+L1ROIreg+L1GEOINFx0)  ! ROI geometry
         T1TFUTUsxROI = T1MEstor(iROI+L1ROIreg+L1GEOINFsx)
         T1TFUTUy0ROI = T1MEstor(iROI+L1ROIreg+L1GEOINFy0)
         T1TFUTUsyROI = T1MEstor(iROI+L1ROIreg+L1GEOINFsy)
c
         iproPo = L1MEstor(iPoi2+L1POpcpo) ! pointer to processor that established point
c
         IF(L1PCstor(iproPo+L1PCtype).eq.L1PCttfu) THEN
            iTFU = L1PCstor(iproPo+L1PCnum) ! get TFU num
            L1TFUTUfromSUP = L1DEFtfudef(L1TFUsup,iTFU) ! superlayer number
            IF (L1TFUTUfromSUP.eq.1) THEN
               incr = 2
            ELSE
               incr = 1
            END IF
            L1TFUTUfromTFU = MOD(iTFU-incr,15)+1 ! form TFU-id within superlayer
         ELSE
            L1TFUTUfromSUP = 0
            L1TFUTUfromTFU = 0
         END IF
c
         IF(HEXIST(L1TFUTUPnr))
     &        CALL HFNT(L1TFUTUPnr)
      ENDIF
      RETURN
c
      END




