*-- Author :    Hartwig Albrecht   16/03/95

      SUBROUTINE LITABL (IL, CTPL)

************************************************************************
*
* Description: List IOstatus of Zebra banks
*
* Called from: anywhere
*
* External references:
*
* Argument in/out description
*   IL     in     ILth link; 0 -> all banks
*   CTPL   in     printer option (Terminal, Printer, Log_file)
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZMMCOM.fi"
#include "auto/MEMS.fi"
#include "auto/MEMO.fi"
#include "auto/MEIO.fi"

      INTEGER IL, I1, I2, IH, L, NR, NC, K1, K2, LENOCC, CHIND1
      CHARACTER CTPL*(*),C1*80,C2*80,CD*1,CH*80,CN*80,CSYM*(80),
     +  CSUB(4)*3, CHO(8)
      DATA CSUB /'par','sub','   ','rel'/

#include "arte/Arte.ff"
#include "auto/MEMS.ff"
#include "auto/MEMO.ff"
#include "auto/MEIO.ff"

      IF (IL .EQ. 0)  THEN
        I1 = 1
        I2 = NARLNK
      ELSE
        IF (IL .LT. 0 .OR. IL .GT. NARLNK)  THEN
          CALL MEERRO ('LITABL: invalid link address')
          GO TO 900
        END IF
        I1 = IL
        I2 = IL
      END IF

      CALL MESELP
     +  ('Link Col  Oc  Rows  Input Output D Name Header Superior',
     +   CTPL)

      DO 30 K1 = I1, I2

        IF (HMEMO_NAME(1,K1) .EQ. HBLANKSP)  GO TO 30
        CALL CHHTOC (IQ(HQMEMO_NAME(1,K1)), CN)

        IH = K1
        C1 = ' '
        IF (IMEMO_SUP(1,IH) .NE. 0)  THEN
          IH = IMEMO_SUP(1,IH)
          CALL CHHTOC (IQ(HQMEMO_NAME(1,IH)), C1)
        END IF
 10     IF (IMEMO_SUP(1,IH) .EQ. 0)  GO TO 20
        IH = IMEMO_SUP(1,IH)
        GO TO 10

 20     CALL CHHTOC (IQ(HQMEMO_NAME(1,IH)), CH)
        C2 = ' '
        IF (IMEMO_SUP(2,K1) .NE. 0)
     +    CALL CHHTOC (IQ(HQMEMO_NAME(1,IMEMO_SUP(2,K1))), C2)

        CD = '?'
        IF (IMEMO_DIV(K1) .EQ. IXEVNT)  CD = 'e'
        IF (IMEMO_DIV(K1) .EQ. IXCONS)  CD = 'c'

        NR = 0
        IF (JLINK(K1) .NE. 0)  NR = N_U (JLINK(K1))

        IF (C1 .EQ. CH .AND. C2 .EQ. ' ')  C1 = ' '

        WRITE (C78, '(3I4,I6,2I7,1X,A)')
     +    K1, IMEMO_COL(K1), IMEMO_OCOL(K1), NR,
     +    IMEMO_NIN(K1), IMEMO_NOUT(K1), CD
        CALL CH78BC (CN)
        IF (IH .NE. K1)  THEN
          CALL CH78BC ('h')
          CALL CH78BC (CH)
        ELSE
          CALL CH78BC ('(header)')
        END IF
        IF (C1 .NE. ' ')  THEN
          CALL CH78BC ('s1')
          CALL CH78BC (C1)
        END IF
        IF (C2 .NE. ' ')  THEN
          CALL CH78BC ('s2')
          CALL CH78BC (C2)
        END IF

        CALL ME78SP (CTPL)

 30   CONTINUE

      CALL MESELP 
     +  ('Link Name        Relations, Parallels, Subordinates',
     +   CTPL)

      DO 60 K1 = I1, I2
        IF (HMEMO_NAME(1,K1) .EQ. HBLANKSP)  GO TO 60
        CALL CHHTOC (IQ(HQMEMO_NAME(1,K1)), CN)
        WRITE (C78, '(I4,1X,A)')  K1, CN

        NC = 0
        DO 50 NR = -2, 1
          IF (NR .EQ. 0)  GO TO 50

          IH = -1
          DO 40 L = IMEMO_SUB1(K1), IMEMO_SUB2(K1)

            K2 = IMEMS_SUB(L)
            NC = MIN (IMEMO_FLAG(K2),1)
            IF (IMEMO_SUP(1,K2) .NE. K1)  NC = MAX (NC, 0)
            IF (NR .NE. NC)  GO TO 40

            IF (IH .LT. 0)  CALL CHAPPC (C78(18:), CSUB(NR+3))

            NC = 1
            IH = 1
            CALL CHHTOC (IQ(HQMEMO_NAME(1,K2)), CN)
            CALL CH78BC (CN)

            IF (LENOCC(C78) .LE. 60)  GO TO 40
            CALL ME78SP (CTPL)
            IH = 0
            WRITE (C78, '(17X,A)')  CSUB(NR+3)

 40       CONTINUE

          IF (IH .GT. 0)  THEN
            CALL ME78SP (CTPL)
            C78 = ' '
          END IF

 50     CONTINUE

 60   CONTINUE

      CALL MESELP ('Link Name        Input< Output>', CTPL)
      IH = 0

      DO 90 K1 = I1, I2
        IF (HMEMO_NAME(1,K1) .EQ. HBLANKSP .OR.
     +      IMEMO_FLAG(K1) .GT. 0)  GO TO 90
        CALL CHHTOC (IQ(HQMEMO_NAME(1,K1)), CN)
        WRITE (C78, '(I4,1X,A)')  K1, CN

        NR = K1
        IF (IMEMO_FLAG (K1) .GT. 0)  THEN          
          NR = IMEMO_SUP(1,K1)
          IF (IMEMO_POS(1,K1) .GT. IMEMO_OCOL(NR))  THEN
            CALL CHAPPC (C78(18:), '/input /output')
            GO TO 80
          END IF
        END IF

        DO 70 L = 1, NMMLUN

          IF (L .EQ. 1)  THEN
            CSYM = 'input'
            IF (BITTEST(BMEMO_IOD(NR),1) .NE. 0 .AND.
     +          BITTEST(BMEMO_IOA(NR),1) .NE. 0)  GO TO 70
          ELSE IF (L .EQ. 2)  THEN
            CSYM = 'output'
            IF (BITTEST(BMEMO_IOD(NR),2) .NE. 0 .AND.
     +          BITTEST(BMEMO_IOA(NR),2) .NE. 0)  GO TO 70
          ELSE
            CALL CHHTOC (IQ(HQMEIO_STREAM(1,IMMLUN(L))), CSYM)
            IF (BITTEST(BMEMO_IOD(NR),L) .EQ. 0 .AND.
     +          BITTEST(BMEMO_IOA(NR),L) .EQ. 0)  GO TO 70
          END IF

          IH = 1
          IF (BITTEST(BMEMO_IOA(NR),L) .EQ. 0)  THEN
            CALL CHAPBC (C78(17:), '/' // CSYM)
          ELSE
            CALL CHAPBC (C78(17:), CSYM)
          END IF

          CALL CHHTOC (IQ(HQMEIO_ZOPTION(1,IMMLUN(L))), CHO)
          IF (CHIND1 (CHO, 'I') .NE. 0)  CALL CH78AC ('<')
          IF (CHIND1 (CHO, 'O') .NE. 0)  CALL CH78AC ('>')

          IF (LENOCC(C78) .LE. 68)  GO TO 70

          CALL ME78SP (CTPL)
          C78 = ' '
          IH = 0

 70     CONTINUE

 80     IF (IH .NE. 0)  CALL ME78SP (CTPL)
        C78 = ' '

 90   CONTINUE

 900  END

************************************************************************
* End of LITABL
************************************************************************
