*-- Author :    Hartwig ALbrecht   06/09/95

      SUBROUTINE LITOPP (IX, CTPL)

************************************************************************
*
* Description: list one entry in the table of particle properties
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   IX     in     row number in table TOPP
*   CTPL   in     teminal / printer / log file
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/TOPP.fi"

      INTEGER IX, I, I1, I2
      CHARACTER *(*) CTPL

#include "arte/Arte.ff"
#include "auto/TOPP.ff"

      IF (IX .LE. 0 .OR. IX .GT. NTOPP())  THEN
        I1 = 1
        I2 = NTOPP()
      ELSE
        I1 = IX
        I2 = IX
      END IF

      C78 = 'part     antipart mass       ch  c d width    trBW        '
     + // 'L  G GA   A life'
      CALL ME78SP (CTPL)

      DO 10 I = I1, I2
      IF (IX .EQ. 0 .AND. I .GT. ITOPP_ANTI(I))  GO TO 10

      C78 = ' '
      IF (ITOPP_ANTI(I) .NE. I .AND.
     +    (HTOPP_NAME(3,I) .NE. HBLANKSP .OR.
     +     HTOPP_NAME(3,ITOPP_ANTI(I)) .NE. HBLANKSP))  THEN
        CALL CHHTOC (IQ(HQTOPP_NAME(1,I)), C78(1:12))
        CALL CHHTOC (IQ(HQTOPP_NAME(1,ITOPP_ANTI(I))), C78(14:25))
        C78(27:27) = '_'
        CALL ME78SP (CTPL)
        C78 = ' '
      ELSE

        CALL CHHTOC (IQ(HQTOPP_NAME(1,I)), C78(1:8))
        IF (ITOPP_ANTI(I) .NE. I)  THEN
          CALL CHHTOC (IQ(HQTOPP_NAME(1,ITOPP_ANTI(I))), C78(10:17))
        ELSE
          CALL CHAPPC (C78(10:), '=')
        END IF
      END IF

      IF (FTOPP_MASS(I) .NE. 0.)  THEN
        WRITE (C78(19:27), '(G9.4)')  FTOPP_MASS(I)
      ELSE
        C78(19:20) = '0.'
      END IF

      WRITE (C78(29:36), '(2I3,I2)')  ITOPP_CHRG(I), ITOPP_COLO(I),
     +  ITOPP_DECA(I)

      IF (FTOPP_WID(I) .NE. 0.)  THEN
        WRITE (C78(38:45), '(G8.3)')  FTOPP_WID(I)
      ELSE
        C78(38:39) = '0.'
      END IF

      IF (FTOPP_TRBW(I) .NE. 0.)  THEN
        WRITE (C78(47:53), '(G7.2)')  FTOPP_TRBW(I)
      ELSE
        C78(47:48) = '0.'
      END IF

      WRITE (C78(54:), 1001)  ITOPP_LUND(I), ITOPP_GEAN(I),
     +  ITOPP_GEAN(ITOPP_ANTI(I)), I, FTOPP_LIFE(I)

      CALL ME78SP (CTPL)

 10   CONTINUE

 1001 FORMAT (I6,2I3,I4,1X,G8.3)

      END

************************************************************************
* End of LITOPP
************************************************************************
