
// Boris Fominykh  31.03.2000
// main routine of muon identification in muon detector
//
//  RTRA tracks are used as a source of seeds for Kalman Filter
//  propagation to muon detector. Obtained track tree is used
//  as a basis for muon likelihood calculation.

#include <iostream.h>
#include <iomanip.h>
#include "usSelect.hh"
#include "arte/arte.hh"

extern "C" {
  void murbwtb_();
  void murbzdin_();
  void murhtinb_();
  void murclinb_();
  void mursdin_();
  void murdwtb_();
  void murtree_();
  void murtabb_();
  void murlhov_();
  void murhtprb_();
  void murclprb_();
  void mursdpr_();
}

extern "C" void MuonID()
{
// book temporary ARTE tables
  murbwtb_();
// calculate the z-ranges  of the reco layers
  murbzdin_();
// collect muon hits
  murhtinb_();
//  murhtprb_();
// make clusters
  murclinb_();
//  murclprb_();
// collect the seeds
  mursdin_();
//  mursdpr_();
// make a track tree
  murtree_();
// hit overlap
  int ipr=0;
  murlhov_(&ipr);
// fill RTRA
  murtabb_();
// close the temporary ARTE tables
  murdwtb_();
  return;
}
