*
*  Boris Fominykh  22.06.98
*  updated  5.04.2000
*  the program of MuonID package
*  selects the best track from the track tree of one seed and
*  rewrites the best branch to IBRAN1 position.
*  input: IBRAN1 - first branch of the track tree
*         IBRAN2 - last branch of the track tree
*         IDEBPR - debug print control, =0 - no print
*
      SUBROUTINE MURSEL1B(IDEBPR,IBRAN1,IBRAN2)
C-    =========================================
      IMPLICIT NONE
#include "murec/MUCBPAR.fi"
#include "murec/MUCBTAB.fi"
      INTEGER NT,IDEBPR,IBRAN1,IBRAN2,BRBEST,IBR,JBR
      INTEGER JBR1,JBR2,I
      REAL EST,ESTBEST
#include "arte/Arte.fi"
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      NT=IQ(JTMP7+2)
      IF(IBRAN1.LE.0)  GOTO 199
      IF(IBRAN2.LE.0)  GOTO 199
      IF(IBRAN1.GT.IBRAN2) GOTO 199
      IF(IBRAN1.GT.NT) GOTO 199
      IF(IBRAN2.GT.NT) GOTO 199
* select the best branch
      ESTBEST = 1000.
      BRBEST  = 0
      DO IBR=IBRAN1,IBRAN2
        JBR=JTMP7+IQ(JTMP7+1)*(IBR-1)+2
        EST=100.*(1.-Q(JBR+47))+Q(JBR+46)
        IF(IQ(JBR+1).EQ.2) THEN 
          IF(EST.LT.ESTBEST) THEN
            ESTBEST=EST
            BRBEST =IBR
          ENDIF
        ENDIF
      ENDDO
      IF(BRBEST.LE.0) GOTO 199      
      JBR1=JTMP7+IQ(JTMP7+1)*(IBRAN1-1)+2
      JBR2=JTMP7+IQ(JTMP7+1)*(BRBEST-1)+2
      DO I=1,20
        IQ(JBR1+I)=IQ(JBR2+I)
      ENDDO
      DO I=21,43
        Q(JBR1+I)=Q(JBR2+I)
      ENDDO
      IQ(JBR1+44)=IQ(JBR2+44)
      DO I=45,47
        Q(JBR1+I)=Q(JBR2+I)
      ENDDO
      DO I=1,NHMUTR
        IQ(JBR1+LCMUTR+I)=IQ(JBR2+LCMUTR+I)
        Q(JBR1+LCMUTR+NHMUTR+I)=Q(JBR2+LCMUTR+NHMUTR+I)
        Q(JBR1+LCMUTR+2*NHMUTR+I)=Q(JBR2+LCMUTR+2*NHMUTR+I)
      ENDDO 
      IFREE=IBRAN1+1

      IF(IDEBPR.GT.0)
     +  WRITE(LLOGF,1001) IBRAN1,IBRAN2,BRBEST,ESTBEST,IFREE
      IF(IDEBPR.GT.0)
     +  PRINT 1001, IBRAN1,IBRAN2,BRBEST,ESTBEST,IFREE
 1001 FORMAT(2X,'in range ',2I4,' the best branch is ',I4,
     +         ' ,estimator= ',E12.4,' IFREE=',I4) 
      GOTO 200
*
 199  CONTINUE
      IFREE=IBRAN1
      IF(IDEBPR.GT.0)
     + WRITE(LLOGF,1002) IBRAN1,IBRAN2,IFREE
      IF(IDEBPR.GT.0)
     + PRINT 1002, IBRAN1,IBRAN2,IFREE
 1002 FORMAT(2X,'in range ',2I4,' NO best branch, IFREE= ',I4)
*
 200  CONTINUE
      RETURN
      END










