
* B.Fominykh  19.06.98
* the program of MUREC-B package
* predicts the hit-map for seed and extrapolates the seed to the superlayers.
* input: ISD - seed number in TMP6
C
      SUBROUTINE MURSHM(ISD)
C-    ======================
      IMPLICIT NONE
      INTEGER ISD,JSD,IHM,IDT,IV,JV,IMS,JSDM,I,J,IJ
      REAL ZEX,XEX,YEX
      REAL X1,X2,Y1,Y2,Z0,CX,CY,TX,TY
      DOUBLE PRECISION PAR(5),COV(4,4)
      DOUBLE PRECISION SX2,SY2,HX(4),HY(4)
*
#include "murec/MUCBZDT.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      IF(IQ(JTMP6+2).LE.0)  GOTO 200
      IF(ISD.GT.IQ(JTMP6+2)) GOTO 200
      JSD=JTMP6+IQ(JTMP6+1)*(ISD-1)+2
      Z0=Q(JSD+5)
       CX=Q(JSD+6)
        CY=Q(JSD+7)
         TX=Q(JSD+8)
          TY=Q(JSD+9)
* Z coordinates of muon superlayers
      Q(JSD+57) = 0.5*(ZMUDT1(1) +ZMUDT2(10))
      Q(JSD+63) = 0.5*(ZMUDT1(11)+ZMUDT2(18))
      Q(JSD+69) = 0.5*(ZMUDT1(19)+ZMUDT2(28))
      Q(JSD+74) = 0.5*(ZMUDT1(29)+ZMUDT2(38))
* seed extrapolation
      DO 10 IMS=1,4
        IF(IMS.LE.2) THEN
          JSDM=JSD+6*IMS+51
        ELSE
          JSDM=JSD+5*IMS+54
        ENDIF
        Q(JSDM+1)=TX*(Q(JSDM)-Z0)+CX
        Q(JSDM+2)=TY*(Q(JSDM)-Z0)+CY
*
        DO I=1,5
          PAR(I)=Q(JSD+4+I)
        ENDDO
        DO I=1,4
          DO J=1,4
            IJ=4*(I-1)+J
            COV(I,J)=Q(JSD+9+IJ)
          ENDDO
        ENDDO
* projection matrix
        HX(1)=1.
        HX(2)=0.
        HX(3)=Q(JSDM)-PAR(1)
        HX(4)=0.

        HY(1)=0.
        HY(2)=1.
        HY(3)=0.
        HY(4)=Q(JSDM)-PAR(1)
* error of extrapolation
        SX2=0.
          SY2=0.
        DO I=1,4
          DO J=1,4
            SX2=SX2+HX(I)*COV(I,J)*HX(J)
            SY2=SY2+HY(I)*COV(I,J)*HY(J)
          ENDDO
        ENDDO

        IF(SX2.GT.1.E-8) THEN
          Q(JSDM+3)=REAL(DSQRT(SX2))
        ELSE
          Q(JSDM+3)=0.
        ENDIF
        IF(SY2.GT.1.E-8) THEN
          Q(JSDM+4)=REAL(DSQRT(SY2))
        ELSE
          Q(JSDM+4)=0.
        ENDIF
        IF(IMS.LE.2) Q(JSDM+5)=SQRT((0.945*Q(JSDM+3))**2+
     +                              (0.325*Q(JSDM+4))**2)
*
  10  CONTINUE        
* loops over hit-map elements (superlayers)
      DO 100 IHM=1,12
* check that momentum is non zero
        IF(IHM.LE.4.AND.Q(JSD+33).LT.0.001)                GOTO 200
        IF(IHM.GT.4.AND.IHM.LE.8.AND.Q(JSD+34).LT.0.001)   GOTO 200
        IF(IHM.GT.8.AND.IHM.LE.10.AND.Q(JSD+35).LT.0.001)  GOTO 200
        IF(IHM.GT.10.AND.IHM.LE.12.AND.Q(JSD+34).LT.0.001) GOTO 200

* loops over detectors
        IF(NMUGEDE(IHM).LE.0) GOTO 100
        DO 50 IDT=1,NMUGEDE(IHM)
          IV=IMUGEDE1(IHM)+IDT-1
          JV=JGEDE+IQ(JGEDE+1)*(IV-1)+2
          ZEX=0.5*(Q(JV+JGEDE_ZMIN)+Q(JV+JGEDE_ZMAX))
          XEX=TX*(ZEX-Z0)+CX
          X1=Q(JV+JGEDE_SXMN)
          IF(XEX.LT.X1) GOTO 50
          X2=Q(JV+JGEDE_SXMX)
          IF(XEX.GT.X2) GOTO 50
          YEX=TY*(ZEX-Z0)+CY
          Y1=Q(JV+JGEDE_SYMN)
          IF(YEX.LT.Y1) GOTO 50
          Y2=Q(JV+JGEDE_SYMX)
          IF(YEX.GT.Y2) GOTO 50
          IF(IHM.LE.8) IQ(JSD+IHM+44)=IQ(JSD+IHM+44)+1
          IF(IHM.EQ.10.OR.IHM.EQ.12) 
     +                 IQ(JSD+IHM+44)=IQ(JSD+IHM+44)+1
          IF(IHM.EQ.9.OR.IHM.EQ.11) 
     +                 IQ(JSD+IHM+44)=IQ(JSD+IHM+44)+2
  50    CONTINUE
 100  CONTINUE
*
 200  CONTINUE
      RETURN
      END
