
*  B.Fominykh  24.04.2000
*  the program of MuonID package
*  calculates the likelihood of space point deflection in MU1, MU2
*
*  input:  MSL      - muon superlayer
*          ISD      - # seed
*          XP(6)    - x,y,z,cov of space point
*          IPR      - print control
*  otput:  LHD      - deflection (position) likelyhood
*
      SUBROUTINE MURSPD(MSL,ISD,IPR,XP,LHD)
C-    =====================================
      IMPLICIT NONE
      INTEGER MSL,ISD,JSD,IPR,I
      REAL XP(6),LHD,Z0,CX,CY,TX,TY,DX,DY,EMS,EXTX,EXTY
      REAL ERX,ERY

#include "murec/MUCBTAB.fi"
#include "arte/Arte.fi"
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      LHD=-1.
      IF(MSL.LT.1.OR.MSL.GT.4)       GOTO 999
      IF(XP(3).LT.1500.)    GOTO 999
      IF(XP(4).LT.0.)       GOTO 999
      IF(XP(5).LT.0.)       GOTO 999
* seed
      IF(JTMP6.LE.0)       GOTO 999
      IF(JTMP6.LE.0)       GOTO 999
      IF(IQ(JTMP6+1).LE.0) GOTO 999
      IF(ISD.LE.0.OR.ISD.GT.IQ(JTMP6+2)) GOTO 999

      JSD=JTMP6+IQ(JTMP6+1)*(ISD-1)+2
* error of multiple scattering
      IF(MSL.LT.3) EMS=Q(JSD+MSL+25)
      IF(MSL.EQ.3) EMS=Q(JSD+29)
      IF(MSL.EQ.4) EMS=Q(JSD+31)
* error of extrapolation
      I=JSD+MSL*6+54
      IF(MSL.EQ.4) I=I-1
      EXTX=Q(I)
      EXTY=Q(I)

      Z0=Q(JSD+5)
      CX=Q(JSD+6)
      CY=Q(JSD+7)
      TX=Q(JSD+8)
      TY=Q(JSD+9)

* position (deflection) likelyhood
      DX=XP(1)-CX-TX*(XP(3)-Z0)
      DY=XP(2)-CY-TY*(XP(3)-Z0)
      ERX=EMS**2+EXTX**2+XP(4)
      ERY=EMS**2+EXTY**2+XP(5)
      LHD=0.5*(ALOG(ERX)+ALOG(ERY)+DX**2/ERX+DY**2/ERY)

 999  CONTINUE
      IF(IPR.GT.0) THEN
        PRINT 1001,MSL,ISD,(XP(I),I=1,3),DX,DY,
     +  EMS,EXTX,EXTY,SQRT(XP(4)),SQRT(XP(5)),LHD
 1001   FORMAT(1X,'MSL',I2,' seed',I4,' XP,YP',2F8.2,' Z',F9.2,
     +     ' dX,dY',2F7.2,/,7X,' err',5F8.2,' LHP',E12.4)
      ENDIF

*
      RETURN
      END




