// 
//  Author:  Wouter Hulsbergen                 Created:  14-Aug-00
//  Modifications:
//

#ifndef rangerMatchedRsegL_HH
#define rangerMatchedRsegL_HH

#ifndef rangerHitBase_HH
#include "rang/HitBase.hh"
#endif

class rangerMatchedRsegL : public rangerHitBase {

public:
  // constructors, destructor, assignment
  rangerMatchedRsegL();
  rangerMatchedRsegL(ArtePointer<RSEG> rseg, rangerFitMode fm, int side);
  virtual ~rangerMatchedRsegL(); 

  // declared in rangerNode
  virtual float dz() { return 0 ; }      // Thickness in z
  virtual int dim() const { return 4 ; } // Dimension of measurement
  virtual int plane(){ return fPlane; }
  virtual float ms() const { return 0; }
  virtual float msPlain() const { return 0; }
  virtual int hasHitb() { return 0; }
  virtual const ArtePointer<HITB> getHitb() const { return 0; } 
  
  // declared in rangerHitBase
  virtual void projectP(HepVector& resid,HepMatrix& HH,rangerStateP* s);
  virtual void projectPI(HepVector& resid,HepMatrix& HH,rangerStatePI* s);
  virtual void projectL(HepVector& resid,HepMatrix& HH,rangerStateL* s);
  virtual void projectLI(HepVector& resid,HepMatrix& HH,rangerStateLI* s);
  virtual void project(HepVector& resid,HepMatrix& HH,rangerState* s);

private:
  ArtePointer<RSEG> fRseg ;  // Arte pointer to RSEG table
  unsigned char fSide ;
  unsigned int fPlane ;
  unsigned char fDim ;
} ;

#endif
