** 
**  Author:  Rainer Mankel                     Created:  26-Jul-99
**           Humboldt University Berlin        Modified:  
**  Email:   mankel@ifh.de                     HERA-B Collaboration
** 

      subroutine tfdownstat()

*
*     statistics downstream propagation of VDS segments into main tracker
*     input and output from/to RSEG table

      implicit none

#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
#include "rang/zf.fi"
#include "rang/ztripl.fi"
#include "rang/zcut.fi"
#include "pris/zpstat.fi"
#include "arte/ArteFlag.fi"
#include "arte/Arte.fi"
#include "auto/MC.fi"
#include "auto/CON.fi"
#include "auto/RSEG.fi"
#include "arte/RSEG_cmp.fi"
#include "rang/descend.fi"

#include "rang/FIXtrit.hh"

*      integer maxlep
*      parameter (maxlep=10)

      integer iiseg,begin_store,istat,mt1,mt2,seg2,iimt,indmt

      integer ns1,ns2,ng2,ts1,ts2,tg2,ncall
      real p,qp
      logical init

      save init,ns1,ns2,ng2,ts1,ts2,tg2,ncall
      data init /.false./, ts1/0/, ts2/0/, tg2/0/, ncall/0/

#include "arte/Arte.ff"
#include "auto/MC.ff"
#include "auto/CON.ff"
#include "auto/RSEG.ff"

      if (.not.init) then
         call hbook1(83001,'q/p all',100,-2.,2.,0.)
         call hbook1(83002,'q/p propagated',100,-2.,2.,0.)
         call hbook1(83003,'pabs all',20,0.,100.,0.)
         call hbook1(83004,'pabs propagated',20,0.,100.,0.)
         init = .true.
      endif

      if(jrseg.le.0) go to 999
      if(NRSEG().lt.1) go to 999

      ncall = ncall + 1

      ns1 = 0
      ns2 = 0
      ng2 = 0

      do 10 iiseg=1,NRSEG()     ! loop over reconstructed segments

         if (irseg_fit(iiseg).ne.0) go to 10  ! select charged track

         if (iand(irseg_cmp(iiseg),rsegc_bitsign).ne.0) go to 10
                                              ! discard killed segment

**         if (iand(irseg_cmp(iiseg),rsegc_sil).eq.0) go to 10
                                              ! demand Si hits
         if (frseg_ze(iiseg).gt.205.) go to 10 ! z cut


*        **** get MC of first segment
         mt1 = 0
         
         do 20 iimt=1,99
            if (iimt.eq.1) then
               indmt = prseg_mtra(iiseg)
            else
               indmt = xrseg_mtra(indmt)
            endif
            if (indmt.le.0) go to 21

            if (xrseg_mtra(indmt).le.0) mt1 = mrseg_mtra(indmt)
            go to 21
 20      continue
 21      continue

         ns1 = ns1 + 1

         p = 0.
         qp = 0.
         seg2 = 0
         mt2 = 0
         if (mt1.gt.0) then
            p = sqrt( fmtra_px(mt1)**2 + fmtra_py(mt1)**2
     +           + fmtra_pz(mt1)**2)
            qp = itopp_chrg(omtra_topp(mt1))/(3.*p)
         endif
         call hfill(83001,qp,0.,1.)
         call hfill(83003,p,0.,1.)

         if (prseg_rend(iiseg).gt.0) then

            ns2 = ns2 + 1

            seg2 = mrseg_rend(prseg_rend(iiseg))
            mt2 = 0

            if (prseg_mtra(seg2).gt.0) then
               mt2 = mrseg_mtra(prseg_mtra(seg2))
            endif


            if (mt1.eq.mt2) then
               ng2 = ng2 + 1
               call hfill(83002,qp,0.,1.)
               call hfill(83004,p,0.,1.)
            endif

         endif
**         print *,' iiseg,seg2,p,mt1,mt2=',iiseg,seg2,p,mt1,mt2

 10   continue

      ts1 = ts1 + ns1
      ts2 = ts2 + ns2
      tg2 = tg2 + ng2

      print *,' -----------tfdownstat---',ncall,'-------------------'
      print *,          ' seg type         ','   evt     total'
      print '((a),2i8)',' VDS segments     ',ns1,ts1
      print '((a),2i8)',' MT  segments     ',ns2,ts2
      print '((a),2i8)',' MT good segments ',ng2,tg2
      print '((a),2f8.4)',' Fraction of good ',
     +     real(ng2)/ns1,real(tg2)/ts1
      print *,' ----------------------------------------------------'


 999  end
