*-- Author :    A.Spiridonov    04/06/99

*#define EXT_TEST

      subroutine tfextfil(ih,dlnext,jpl,ift,izf,izfnew,istat)

*     **** absorb the next hit (3D version , external-ranger)

      implicit none

#include "rang/zseed.fi"
#include "rang/zf.fi"
#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
#include "rang/zfpar_ext.fi"
#include "rang/zfmode.fi"
#include "rang/zplx.fi"
#include "pris/zpstat.fi"
#include "rang/zfparext.fi"
#include "gean/ZGESL.fi"

      integer ih, jpl, izf, izfnew, xsig_min, xsig_max, del_xsig, xsig,
     +        jzf, ift, jft, ii, jj, kk, istat, tumchit,
     +        dlnext, cmp, tfmc
      integer message_id_1, message_id_2
      double precision dz, du, cs_thetu, xm_p, xr_p,
     +        cr_p, hch, kalman(dimp,dimm), ihk, m_u, sum, f(5,5)
      real wc(3), xxx(2), yyy(2), qptmax, x_border, y_border,
     +     x_margin, y_margin
*      parameter (qptmax=2.)  ! max q/pt (0.5 GeV)
      parameter (qptmax=0.96)  ! max q/pt (1 GeV)

      double precision xp_LEFT(5),cp_LEFT(5,5)
*-------------------------------------------
      character*1 tfcsig

#include "rang/descend.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"

      save    message_id_1, message_id_2
      data    message_id_1 /1/,message_id_2 /2/

      integer N_h_zf
      double precision h_1,h_2,k_1,k_2,k_3,k_4,k_5
      double precision c11,c12,c13,c14,c15
      double precision c21,c22,c23,c24,c25
      double precision kh_1,kh_2,kh_3,kh_4,kh_5,x,y

      integer gold,jgold

      integer imc,i_hit/0/,ifail     
      real dx_s
      double precision d_test(4,4)

#ifdef EXT_TEST
      integer i_good
      real xr_pm,cxr_pm
#endif

      real sigma_pit
      data sigma_pit/0.3849/    !  4/(3*sqrt(12))

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"

      kh_1(x,y) = k_1 * ( h_1 * x + h_2 * y )
      kh_2(x,y) = k_2 * ( h_1 * x + h_2 * y )
      kh_3(x,y) = k_3 * ( h_1 * x + h_2 * y )
      kh_4(x,y) = k_4 * ( h_1 * x + h_2 * y )
      kh_5(x,y) = k_5 * ( h_1 * x + h_2 * y )

      if (diag_level.ge.5)
     +  print *,' tfextfil: absorb ih, jpl, imc=', ih, jpl, tumchit(ih)

      izfnew = 0

      if (igede_cmp(jpl).eq.lgesl_wch.and.drift_distance.ne.0) then
       xsig_min = -1
       xsig_max = +1
       del_xsig = +2
      else
       xsig_min = 0
       xsig_max = 0
       del_xsig = +2
      endif

      dz = fhitb_z(ih) - z_zf(izf)

*     switch off drift-time

*      if (drift_distance.eq.0) then 
*        q(qhitb_q(ih)) = 0.
*      end if

*     **** loop over L/R signs

      do 10 xsig=xsig_min,xsig_max,del_xsig
       istat = 0
       if (n_zf.ge.nzfmx) then
        istat = -10
        call mepric(message_id_1,3,
     +       'tfextfil: ranger buffer at limit, track aborted')
        go to 999
       endif
       jzf = n_zf + 1

*      **** Kalman filter prediction

       if(xsig.ne.1) then

         call tftctranZ(ih,izf,jzf,istat) ! short cut

         if(xsig.eq.-1) then                            ! store LEFT for sign
           do ii=1,5
             xp_LEFT(ii) = xp_zf(ii,jzf)
             do jj=1,5
               cp_LEFT(ii,jj) = cp_zf(ii,jj,jzf)
             end do 
           end do
         end if
         else if(xsig.eq.1) then                        ! restore for RIGHT 
           do ii=1,5
             xp_zf(ii,jzf) = xp_LEFT(ii)
             do jj=1,5
               cp_zf(ii,jj,jzf) = cp_LEFT(ii,jj)
             end do
           end do
         end if

       if (istat.lt.0) then
        print *,' tfextfil: transport was impossible, abort sign,',
     +         ' ih,ift,izf=',ih,ift,izf
        go to 10
       endif

       if (diag_level.ge.5) then
        print *,' tfextfil: start was xx(4), sq(cx(4))=',
     +            xx_zf(4,izf), dsqrt(cx_zf(4,4,izf))
        print *,' tfextfil: pred=', xp_zf(2,jzf),
     +         ' error ', dsqrt( cp_zf(2,2,jzf) ), 'dz=', dz
        print *,' cp_zf(2,2,jzf), cp_zf(2,4,jzf), cp_zf(4,4,jzf)=',
     +           cp_zf(2,2,jzf), cp_zf(2,4,jzf), cp_zf(4,4,jzf)
       endif

*      **** projection

      if (igede_cmp(jpl).eq.lgesl_wch.and.drift_distance.ne.0) then

        xm_zf(1,jzf)   = xsig * abs( fhitb_q(ih) )
        cm_zf(1,1,jzf) = fhitb_r(ih)**2

*       **** tan(track angle) in uz-plane
        m_u = xp_zf(3,jzf) * cstot_plx(jpl)
     +                                 - xp_zf(4,jzf) * sntot_plx(jpl)
        cs_thetu = 1. / dsqrt(1.d0 + m_u**2)
*       **** distance from projection to wire (along u)
        du = xp_zf(1,jzf) * cstot_plx(jpl)
     +     - xp_zf(2,jzf) * sntot_plx(jpl) - fhitb_x(ih)
        xm_p      = du * cs_thetu
*       **** difference to signed drift distance
***        xr_p = xsig * abs( fhitb_q(ih) ) - xm_p
        xr_p = xm_zf(1,jzf) - xm_p

        if(abs(sntot_plx(jpl)).lt.1.e-3) then                ! X -chambers

          N_h_zf = 1

          h_zf(1,1,jzf) =   cstot_plx(jpl) * cs_thetu
          h_zf(1,2,jzf) = 0.
          h_zf(1,3,jzf) = 0.
          h_zf(1,4,jzf) = 0.
          h_zf(1,5,jzf) = 0.

          hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
          
*          print '("tfextfil : h,c ",2(x,f8.3))'
*     +    , h_zf(1,1,jzf),dsqrt(cp_zf(1,1,jzf))

        else                                                 ! Y - chamber

          N_h_zf = 2

          h_zf(1,1,jzf) =   cstot_plx(jpl) * cs_thetu
          h_zf(1,2,jzf) = - sntot_plx(jpl) * cs_thetu
          h_zf(1,3,jzf) = 0.
          h_zf(1,4,jzf) = 0.
          h_zf(1,5,jzf) = 0.

          hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
     +        +  h_zf(1,2,jzf)**2 * cp_zf(2,2,jzf)
     +        + 2.d0 * ( h_zf(1,1,jzf) * h_zf(1,2,jzf) * cp_zf(1,2,jzf))

*          print '("tfextfil : h,c ",5(x,f8.3))'
*     +    ,h_zf(1,1,jzf),h_zf(1,2,jzf)
*     +    ,dsqrt(cp_zf(1,1,jzf))
*     +    ,cp_zf(1,2,jzf)/(dsqrt(cp_zf(1,1,jzf))*dsqrt(cp_zf(2,2,jzf)))     
*     +    ,dsqrt(cp_zf(2,2,jzf))

        end if

*        print '(/"sin,H= ",5(f9.4) )',sntot_plx(jpl),h_zf(1,1,jzf)
*     +         ,h_zf(1,2,jzf),h_zf(1,3,jzf),h_zf(1,4,jzf)

       cr_p = cm_zf(1,1,jzf) + hch

*??
      else if (igede_cmp(jpl).eq.lgesl_wch
     +         .and.drift_distance.eq.0) then

**        xm_zf(1,jzf)   = xsig * abs( fhitb_q(ih) )
        xm_zf(1,jzf)   = 0.
**        cm_zf(1,1,jzf) = fhitb_r(ih)**2
        cm_zf(1,1,jzf) = (fgede_pit(jpl)*sigma_pit)**2

*       **** tan(track angle) in uz-plane
        m_u = xp_zf(3,jzf) * cstot_plx(jpl)
     +                                 - xp_zf(4,jzf) * sntot_plx(jpl)
        cs_thetu = 1. / dsqrt(1.d0 + m_u**2)
*       **** distance from projection to wire (along u)
        du = xp_zf(1,jzf) * cstot_plx(jpl)
     +     - xp_zf(2,jzf) * sntot_plx(jpl) - fhitb_x(ih)
        xm_p      = du * cs_thetu

*       **** difference to signed drift distance
***        xr_p = xsig * abs( fhitb_q(ih) ) - xm_p
        xr_p = xm_zf(1,jzf) - xm_p

        if(abs(sntot_plx(jpl)).lt.1.e-3) then                ! X -chambers

          N_h_zf = 1

          h_zf(1,1,jzf) =   cstot_plx(jpl) * cs_thetu
          h_zf(1,2,jzf) = 0.
          h_zf(1,3,jzf) = 0.
          h_zf(1,4,jzf) = 0.
          h_zf(1,5,jzf) = 0.

          hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
          
*          print '("tfextfil : h,c ",2(x,f8.3))'
*     +    , h_zf(1,1,jzf),dsqrt(cp_zf(1,1,jzf))

        else                                                 ! Y - chamber

          N_h_zf = 2

          h_zf(1,1,jzf) =   cstot_plx(jpl) * cs_thetu
          h_zf(1,2,jzf) = - sntot_plx(jpl) * cs_thetu
          h_zf(1,3,jzf) = 0.
          h_zf(1,4,jzf) = 0.
          h_zf(1,5,jzf) = 0.

          hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
     +        +  h_zf(1,2,jzf)**2 * cp_zf(2,2,jzf)
     +        + 2.d0 * ( h_zf(1,1,jzf) * h_zf(1,2,jzf) * cp_zf(1,2,jzf))

*          print '("tfextfil : h,c ",5(x,f8.3))'
*     +    ,h_zf(1,1,jzf),h_zf(1,2,jzf)
*     +    ,dsqrt(cp_zf(1,1,jzf))
*     +    ,cp_zf(1,2,jzf)/(dsqrt(cp_zf(1,1,jzf))*dsqrt(cp_zf(2,2,jzf)))     
*     +    ,dsqrt(cp_zf(2,2,jzf))

        end if

*        print '(/"sin,H= ",5(f9.4) )',sntot_plx(jpl),h_zf(1,1,jzf)
*     +         ,h_zf(1,2,jzf),h_zf(1,3,jzf),h_zf(1,4,jzf)

       cr_p = cm_zf(1,1,jzf) + hch

       elseif (igede_cmp(jpl).eq.lgesl_msg) then

        xm_zf(1,jzf)   = fhitb_x(ih)
        cm_zf(1,1,jzf) = fhitb_r(ih)**2
        xm_p = xp_zf(1,jzf) * fgede_rot(1,jpl)
     +       - xp_zf(2,jzf) * fgede_rot(2,jpl)
        xr_p = fhitb_x(ih) - xm_p

        N_h_zf = 2

        h_zf(1,1,jzf) =  fgede_rot(1,jpl)
        h_zf(1,2,jzf) = -fgede_rot(2,jpl)
        h_zf(1,3,jzf) = 0.
        h_zf(1,4,jzf) = 0.
        h_zf(1,5,jzf) = 0.
        hch = cp_zf(1,1,jzf) * h_zf(1,1,jzf)**2
     +    + 2.d0 * cp_zf(1,2,jzf) * h_zf(1,1,jzf) * h_zf(1,2,jzf)
     +    + cp_zf(2,2,jzf) * h_zf(1,2,jzf)**2
        cr_p = cm_zf(1,1,jzf) + hch

       elseif (igede_cmp(jpl).eq.lgesl_sil) then

        xm_zf(1,jzf)   = fhitb_x(ih)
        cm_zf(1,1,jzf) = fhitb_r(ih)**2
        xm_p = xp_zf(1,jzf) * cstot_plx(jpl)
     +       - xp_zf(2,jzf) * sntot_plx(jpl)
        xr_p = fhitb_x(ih) - xm_p

        N_h_zf = 2

        h_zf(1,1,jzf) =  cstot_plx(jpl)
        h_zf(1,2,jzf) = -sntot_plx(jpl)
        h_zf(1,3,jzf) = 0.
        h_zf(1,4,jzf) = 0.
        h_zf(1,5,jzf) = 0.
        hch = cp_zf(1,1,jzf) * h_zf(1,1,jzf)**2
     +    + 2.d0 * cp_zf(1,2,jzf) * h_zf(1,1,jzf) * h_zf(1,2,jzf)
     +    + cp_zf(2,2,jzf) * h_zf(1,2,jzf)**2
        cr_p = cm_zf(1,1,jzf) + hch
       else
        print *,' tfextfil: non-supported type for jpl=', jpl
       endif

*       print '(/"cmp,Sr,sin,H ",i2,6(f7.4))'
*    +        ,igede_cmp(jpl),fhitb_r(ih),sntot_plx(jpl)
*     +        ,h_zf(1,1,jzf),h_zf(1,2,jzf),h_zf(1,3,jzf),h_zf(1,4,jzf)

       if (diag_level.ge.5) then
               print *,' tfextfil: fhitb_x(ih), xm_p, xr_p, er_p=',
     +         fhitb_x(ih), xm_p, xr_p, dsqrt(cr_p)

               print *,' hch, fhitb_r(ih)**2, cr_p=',
     +           hch, fhitb_r(ih)**2, cr_p
       endif

#ifdef EXT_TEST
       i_good = 0

       if(xsig.eq.-1) then      ! all tracks

**         xr_pm = fhitb_q(ih) * 0.  - xm_p         !  drift distance = 0
         xr_pm = fhitb_q(ih) * 1.  - xm_p         !  drift distance .ne. 0

**       if (abs( fhitb_q(ih) ).lt. 0.1 ) then
**         xr_pm = fhitb_q(ih) * 1.  - xm_p         !  drift distance = 0
**       else 
**         xr_pm = 1.e6
**       end if

         cxr_pm = dsqrt(cr_p)

         if(abs(sntot_plx(jpl)).lt.1.e-3) then    ! x-hit

           call hf1(id_hist+211,xr_pm,1.)
           call hf1(id_hist+213,xr_pm/cxr_pm,1.)

         else                                     ! u,v-hit

           call hf1(id_hist+212,xr_pm,1.)
           call hf1(id_hist+214,xr_pm/cxr_pm,1.)

         end if
       end if


       if(mc_zf(izf).gt.0.and.xsig.eq.-1) then      ! MC track is defined
         if(mc_zf(izf).eq.tumchit(ih)) then ! good hit

           i_good = 1

*           xr_pm = fhitb_q(ih) - xm_p

**           print '("tfextfil : xm_mimp,xm_p,qh,xr_p,xr_pm ",5f8.3)'
**     +             ,xm_mimp,xm_p,fhitb_q(ih),xr_p,xr_pm

           if(abs(sntot_plx(jpl)).lt.1.e-3) then    ! x-hit

             call hf1(id_hist+311,xr_pm,1.)
             call hf1(id_hist+313,xr_pm/cxr_pm,1.)

           else                                     ! u,v-hit

             call hf1(id_hist+312,xr_pm,1.)
             call hf1(id_hist+314,xr_pm/cxr_pm,1.)

           end if
         end if
       end if

       if(xsig.eq.-1.and.i_good.eq.0) then      ! bad tracks

*         xr_pm = fhitb_q(ih) - xm_p

         if(abs(sntot_plx(jpl)).lt.1.e-3) then    ! x-hit

           call hf1(id_hist+411,xr_pm,1.)
           call hf1(id_hist+413,xr_pm/cxr_pm,1.)

         else                                     ! u,v-hit

           call hf1(id_hist+412,xr_pm,1.)
           call hf1(id_hist+414,xr_pm/cxr_pm,1.)

         end if
       end if

       izfnew = 0
       quality_ft(ift) = -100.
       go to 10
*     -----------------------            kill ift - candidate
#endif

*      **** decision

*       if(plane_zf(izf).eq.0) then 
*         print '("tfextfil : dx/sqrt(chmx*cr_p)=",f8.3)'
*     +         ,(dabs(xr_p)/dsqrt(chmax_ext_zfpar*cr_p))
*       end if

*       print '(/"tfextfil:   test ih,cmp,z,alf,dx/s "
*     + ,(i4),i2,(x,f8.3),(x,f6.3),(x,f7.2))'
*     + ,ih,igede_cmp(jpl)
*     + ,fhitb_z(ih)
*     + ,sntot_plx(jpl),dabs(xr_p)/dsqrt(cr_p)

       if (dabs(xr_p).gt.dsqrt(chmax_ext_zfpar*cr_p)) then

        if (diag_level.ge.5) then
         print *,' tfextfil: hit dropped due to nsigma,',
     +       ' dabs(xr_p), dsqrt(chmax*cr_p)=',
     +       dabs(xr_p), dsqrt(chmax_ext_zfpar*cr_p)
        endif
        go to 10
       endif

*      **** filter point
       do ii=1,5
         if(N_h_zf.eq.1) then
          kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf) ) / cr_p
         else if(N_h_zf.eq.2) then
          kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf)
     +                   + cp_zf(ii,2,jzf) * h_zf(1,2,jzf) ) / cr_p
         else
          kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf)
     +                   + cp_zf(ii,2,jzf) * h_zf(1,2,jzf)
     +                   + cp_zf(ii,3,jzf) * h_zf(1,3,jzf)
     +                   + cp_zf(ii,4,jzf) * h_zf(1,4,jzf)
     +                   + cp_zf(ii,5,jzf) * h_zf(1,5,jzf) ) / cr_p
         end if
       enddo

*      print '(/"Sr,sin,K ",7(f8.4))'
*     +       ,fhitb_r(ih),sntot_plx(jpl)
*     +       ,kalman(1,1),kalman(2,1),kalman(3,1)
*     +       ,kalman(4,1),kalman(5,1)

*      **** updated x value

       do ii=1,5
        xx_zf(ii,jzf) = xp_zf(ii,jzf) + kalman(ii,1) * xr_p
       enddo

*      **** updated cov matrix

      if(N_h_zf.eq.1) then

        h_1 = h_zf  (1,1,jzf)
        k_1 =  kalman(1,1) * h_1 
        k_2 =  kalman(2,1) * h_1
        k_3 =  kalman(3,1) * h_1
        k_4 =  kalman(4,1) * h_1
        k_5 =  kalman(5,1) * h_1

        c11 = cp_zf(1,1,jzf)
        c12 = cp_zf(1,2,jzf)
        c13 = cp_zf(1,3,jzf)
        c14 = cp_zf(1,4,jzf)
        c15 = cp_zf(1,5,jzf)

        cx_zf(1,1,jzf) = (1.d0 - k_1) * c11
        cx_zf(1,2,jzf) = (1.d0 - k_1) * c12
        cx_zf(1,3,jzf) = (1.d0 - k_1) * c13
        cx_zf(1,4,jzf) = (1.d0 - k_1) * c14
        cx_zf(1,5,jzf) = (1.d0 - k_1) * c15

        cx_zf(2,1,jzf) = cx_zf(1,2,jzf)
        cx_zf(2,2,jzf) = cp_zf(2,2,jzf) - k_2 * c12
        cx_zf(2,3,jzf) = cp_zf(2,3,jzf) - k_2 * c13
        cx_zf(2,4,jzf) = cp_zf(2,4,jzf) - k_2 * c14
        cx_zf(2,5,jzf) = cp_zf(2,5,jzf) - k_2 * c15

        cx_zf(3,1,jzf) = cx_zf(1,3,jzf) 
        cx_zf(3,2,jzf) = cx_zf(2,3,jzf)
        cx_zf(3,3,jzf) = cp_zf(3,3,jzf) - k_3 * c13
        cx_zf(3,4,jzf) = cp_zf(3,4,jzf) - k_3 * c14
        cx_zf(3,5,jzf) = cp_zf(3,5,jzf) - k_3 * c15

        cx_zf(4,1,jzf) = cx_zf(1,4,jzf) 
        cx_zf(4,2,jzf) = cx_zf(2,4,jzf)
        cx_zf(4,3,jzf) = cx_zf(3,4,jzf)
        cx_zf(4,4,jzf) = cp_zf(4,4,jzf) - k_4 * c14
        cx_zf(4,5,jzf) = cp_zf(4,5,jzf) - k_4 * c15

        cx_zf(5,1,jzf) = cx_zf(1,5,jzf) 
        cx_zf(5,2,jzf) = cx_zf(2,5,jzf)
        cx_zf(5,3,jzf) = cx_zf(3,5,jzf)
        cx_zf(5,4,jzf) = cx_zf(4,5,jzf)
        cx_zf(5,5,jzf) = cp_zf(5,5,jzf) - k_5 * c15

      else if(N_h_zf.eq.2) then

        h_1 = h_zf  (1,1,jzf)
        h_2 = h_zf  (1,2,jzf)
        k_1 =  kalman(1,1)  
        k_2 =  kalman(2,1) 
        k_3 =  kalman(3,1) 
        k_4 =  kalman(4,1) 
        k_5 =  kalman(5,1) 

        c11 = cp_zf(1,1,jzf)
        c12 = cp_zf(1,2,jzf)
        c13 = cp_zf(1,3,jzf)
        c14 = cp_zf(1,4,jzf)
        c15 = cp_zf(1,5,jzf)

        c21 = cp_zf(2,1,jzf)
        c22 = cp_zf(2,2,jzf)
        c23 = cp_zf(2,3,jzf)
        c24 = cp_zf(2,4,jzf)
        c25 = cp_zf(2,5,jzf)

        cx_zf(1,1,jzf) = c11 - kh_1 ( c11 , c21 ) 
        cx_zf(1,2,jzf) = c12 - kh_1 ( c12 , c22 )
        cx_zf(1,3,jzf) = c13 - kh_1 ( c13 , c23 )
        cx_zf(1,4,jzf) = c14 - kh_1 ( c14 , c24 )
        cx_zf(1,5,jzf) = c15 - kh_1 ( c15 , c25 )

        cx_zf(2,1,jzf) = cx_zf(1,2,jzf)
        cx_zf(2,2,jzf) = cp_zf(2,2,jzf) - kh_2 ( c12 , c22 )
        cx_zf(2,3,jzf) = cp_zf(2,3,jzf) - kh_2 ( c13 , c23 )
        cx_zf(2,4,jzf) = cp_zf(2,4,jzf) - kh_2 ( c14 , c24 )
        cx_zf(2,5,jzf) = cp_zf(2,5,jzf) - kh_2 ( c15 , c25 )

        cx_zf(3,1,jzf) = cx_zf(1,3,jzf) 
        cx_zf(3,2,jzf) = cx_zf(2,3,jzf)
        cx_zf(3,3,jzf) = cp_zf(3,3,jzf) - kh_3 ( c13 , c23 )
        cx_zf(3,4,jzf) = cp_zf(3,4,jzf) - kh_3 ( c14 , c24 )
        cx_zf(3,5,jzf) = cp_zf(3,5,jzf) - kh_3 ( c15 , c25 )

        cx_zf(4,1,jzf) = cx_zf(1,4,jzf) 
        cx_zf(4,2,jzf) = cx_zf(2,4,jzf)
        cx_zf(4,3,jzf) = cx_zf(3,4,jzf)
        cx_zf(4,4,jzf) = cp_zf(4,4,jzf) - kh_4 ( c14 , c24 )
        cx_zf(4,5,jzf) = cp_zf(4,5,jzf) - kh_4 ( c15 , c25 )

        cx_zf(5,1,jzf) = cx_zf(1,5,jzf) 
        cx_zf(5,2,jzf) = cx_zf(2,5,jzf)
        cx_zf(5,3,jzf) = cx_zf(3,5,jzf)
        cx_zf(5,4,jzf) = cx_zf(4,5,jzf)
        cx_zf(5,5,jzf) = cp_zf(5,5,jzf) - kh_5 ( c15 , c25 )

      else

       do ii=1,5
        do jj=1,5
         cx_zf(ii,jj,jzf) = 0.
        enddo
       enddo

       do ii=1,5
        do jj=ii,5
         sum = 0.
         do kk=1,5
          if (ii.eq.kk) then
           sum = sum +
     +       (1.d0 - kalman(ii,1) * h_zf(1,kk,jzf)) * cp_zf(kk,jj,jzf)
          else
           sum = sum - kalman(ii,1) * h_zf(1,kk,jzf) * cp_zf(kk,jj,jzf)
          endif
         enddo
         cx_zf(ii,jj,jzf) = sum
         if (ii.ne.jj) cx_zf(jj,ii,jzf) = sum
        enddo
       enddo
      end if
    
#ifdef TC_TEST
*      print *,'jzf izf N_h cx44',jzf,N_h_zf,cx_zf(4,4,jzf)

      print '("tfextfil : cmp sntot_plx(jpl) ",i2,x,f8.3)'
     +        ,igede_cmp(jpl),sntot_plx(jpl)
      call tftcmtest(cx_zf,izf,'fil cx_zf izf  ',izf)
      call tftcmtest(cp_zf,jzf,'    cp_zf jzf  ',jzf)
      call tftcmtest(cx_zf,jzf,'    cx_zf jzf  ',jzf)
#endif


       if (cx_zf(4,4,jzf).lt.0.d0
     +  .or.dabs(cx_zf(3,4,jzf)/dsqrt(cx_zf(3,3,jzf)*cx_zf(4,4,jzf)))
     +  .gt.1.d0 ) then

#ifdef RT_TEST
        print '(/"tfextfil: cr_p, jzf= ",f8.3,i5)', cr_p, jzf
        print '("in jzf z_zf(jzf) ro(tx,ty)",i4,2(x,f8.3))'
     +        ,jzf,z_zf(jzf)
     +        ,cp_zf(3,4,jzf)/dsqrt(cp_zf(3,3,jzf)*cp_zf(4,4,jzf))
        print '("pin xp_zf:",5(e11.4))',(xp_zf(ii,jzf),ii=1,5)
        print '("cp_zf 1:",5(e11.4))',(cp_zf(1,ii,jzf),ii=1,5)
        print '("cp_zf 2:",5(e11.4))',(cp_zf(2,ii,jzf),ii=1,5)
        print '("cp_zf 3:",5(e11.4))',(cp_zf(3,ii,jzf),ii=1,5)
        print '("cp_zf 4:",5(e11.4))',(cp_zf(4,ii,jzf),ii=1,5)
        print '("cp_zf 5:",5(e11.4))',(cp_zf(5,ii,jzf),ii=1,5)
        print '(/"out fhitb_z,ro(tx,ty) ",f9.3,f9.3)'
     +         ,fhitb_z(ih)
     +        ,cx_zf(3,4,jzf)/dsqrt(cx_zf(3,3,jzf)*cx_zf(4,4,jzf))
        print'("h_1,2,ige_cmp",f9.3,f9.3,i3)',h_1,h_2,igede_cmp(jpl)
        print'("fhitb_r,cm_cf11,hch",f9.3,f9.3,f9.3)'
     +          ,fhitb_r(ih),cm_zf(1,1,jzf),hch
        print '("k1. ",5(1x,f8.3))',k_1,k_2,k_3,k_4,k_5
        print '("pou xx_zf:",5(e11.4))',(xx_zf(ii,jzf),ii=1,5)
        print '("cx 1:",5(e11.4))',(cx_zf(1,ii,jzf),ii=1,5)
        print '("cx 2:",5(e11.4))',(cx_zf(2,ii,jzf),ii=1,5)
        print '("cx 3:",5(e11.4))',(cx_zf(3,ii,jzf),ii=1,5)
        print '("cx 4:",5(e11.4))',(cx_zf(4,ii,jzf),ii=1,5)
        print '("cx 5:",5(e11.4))',(cx_zf(5,ii,jzf),ii=1,5)
#endif

*       ****  try fix , track should be continued   

        cx_zf(3,4,jzf) =  cx_zf(3,4,jzf) / 2. 
        cx_zf(4,3,jzf) =  cx_zf(3,4,jzf)

       endif

*      **** updated residual
 
       if(N_h_zf.eq.1) then
         ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
       else if(N_h_zf.eq.2) then
         ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
     +            - h_zf(1,2,jzf) * kalman(2,1)
       else  

         ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
     +            - h_zf(1,2,jzf) * kalman(2,1)
     +            - h_zf(1,3,jzf) * kalman(3,1)
     +            - h_zf(1,4,jzf) * kalman(4,1)
     +            - h_zf(1,5,jzf) * kalman(5,1)
       end if

       xr_zf(1,jzf) = xr_p * ihk
       cr_zf(1,1,jzf) = cm_zf(1,1,jzf) * ihk

*      **** updated chi2 contribution

       ch_zf(jzf) = xr_zf(1,jzf)**2 / cr_zf(1,1,jzf)

       if (diag_level.ge.5) then
        print *,'>ihk, xr_zf(1,jzf), cr_zf(1,1,jzf), ch2=',
     +            ihk, xr_zf(1,jzf), cr_zf(1,1,jzf), ch_zf(jzf)
       endif

*      **** cut on chi**2 contribution

*       if(plane_zf(izf).eq.0) then 
*         print '("tfextfil : ch/chmx)=",f8.3)'
*     +         ,(ch_zf(jzf)/chmax_ext_zfpar)
*       end if

       if (ch_zf(jzf).gt.chmax_ext_zfpar) then
        go to 10
       endif

#ifndef OLDCHECK
*      **** check if hit is really inside plane
       x_margin = 2.
       y_margin = 2.
       y_border = xx_zf(1,jzf) * fgede_rot(2,jpl)
     +      + xx_zf(2,jzf) * fgede_rot(1,jpl)
       if (y_border.lt.(fgede_symn(jpl)-y_margin)) go to 10
       if (y_border.gt.(fgede_symx(jpl)+y_margin)) go to 10
       x_border = xx_zf(1,jzf) * fgede_rot(1,jpl)
     +      - xx_zf(2,jzf) * fgede_rot(2,jpl)
       if (igede_shp(jpl).eq.10) x_border = x_border 
     +      - y_border * fgede_sin(jpl) / fgede_cos(jpl)
       if (x_border.lt.(fgede_sxmn(jpl)-x_margin)) go to 10
       if (x_border.gt.(fgede_sxmx(jpl)+x_margin)) go to 10
#endif

*      **** accept hit

       hit_zf(jzf)   = ih
       nhit_zf(jzf) = nhit_zf(izf) + 1
       plane_zf(jzf) = ihitb_gede(ih)
       cmp = igede_cmp(plane_zf(jzf))
       if (cmp.le.maxcmp_zfpar) then
          whit_zf(jzf) = whit_zf(izf) + whit_cmp_zfpar(cmp)
       else
          whit_zf(jzf) = whit_zf(izf) + 1.
       endif
       domlay_zf(jzf) = dlnext
       z_zf(jzf) = fhitb_z(ih)
       cht_zf(jzf) = cht_zf(izf) + ch_zf(jzf)
       sign_zf(jzf) = xsig
       prev_zf(jzf) = izf
       fault_zf(jzf) = 0
       pfault_zf(jzf) = fault_zf(izf)
       dim_zf(jzf) = 1
       shadow_zf(jzf) = 0
       n_zf = n_zf + 1

       izfnew = jzf

**       print '("tfextfil : hit accepted ih,cmp,mc,nh,ift,sig ",6i4)'
**     +        ,ih,cmp,tfmc(jzf),nhit_zf(jzf),ift,xsig

*      **** fill candidate info

       if (nca_ft.ge.ncamx) then
        print *,' () tfextfil: candidate overflow, nca_ft=', nca_ft
        stop 'tfcfil'
       endif
       nca_ft = nca_ft + 1
       jft = nca_ft
       first_ft(jft) = first_ft(ift)
       if (diag_level.ge.5) print *,' clone candidate, jft=', jft
       nhit_ft(jft)     = nhit_zf(jzf)
       last_ft(jft)     = jzf
       prev_ft(jft)     = prev_ft(ift)
       gen_ft(jft)      = gen_ft(ift) + 1
       nfault_ft(jft)   = nfault_ft(ift)
       quality_ft(jft)  = quality_ft(ift)
     +                    + 1.               ! bonus for new hit
     +                    - wchi_ext_zfpar * ch_zf(jzf) ! malus for chi2

       alive_ft(jft)    = .true.
       mature_ft(jft)   = .false.
       stat_ft(jft) = stat_ft(ift)

       descend(jft) = ift_descend
       ift_preced(jft) = ift

*       print '(/"tfextfil:ih,jft,hh,cmp,z,alf,q,ch "
*     + ,2(i4),i3,i2,(x,f8.3),(x,f6.3),2(x,f6.1))'
*     + ,ih,jft,nhit_ft(jft),igede_cmp(jpl)
*     + ,z_zf(jzf)
*     + ,sntot_plx(jpl),quality_ft(jft),ch_zf(jzf)
***     + ,xm_zf(1,jzf),ch_zf(jzf)

*       print '("x =",5(x,f8.3))',(xx_zf(ii,jzf),ii=1,5)
*       print '("c =",5(x,f8.3))',(dsqrt(cx_zf(ii,ii,jzf)),ii=1,5)

 10   continue

      istat = 0

 999  end
