*-- Author :    Rainer Mankel   08/02/95

      subroutine tfparmft(ift)

*     **** check reconstructed track parameters against MC
      implicit none
      double precision covi(5,5), covip(5,5), x(5), c(5,5)
      real tfmitoqpt, pamc(5), dpamc(5), ch2mc, ex(5)
      integer i, j, ndf, izf, ifail, mimp, ift, tfmc, tfmimp
#include "arte/Arte.fi"

#include "rang/zf.fi"


#include "auto/HITB.fi"
#include "auto/MIMP.fi"

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"

      if (stat_ft(ift).eq.1) then
         ndf = 2
      elseif (stat_ft(ift).eq.2) then
         ndf = 2
      else
         ndf = 5
      endif

      izf = last_ft(ift)
      mimp = tfmimp(izf)

      if (stat_ft(ift).eq.3.or.stat_ft(ift).eq.5) then
         do i=1,5
            x(i) = xs_zf(i,izf)
            do j=1,5
               c(i,j) = cs_zf(i,j,izf)
            enddo
         enddo
      elseif (stat_ft(ift).le.2.or.stat_ft(ift).eq.4) then
         do i=1,5
            x(i) = xx_zf(i,izf)
            do j=1,5
               c(i,j) = cx_zf(i,j,izf)
            enddo
         enddo
      else
         print *,' () tfparmft: unsupported stat_ft=', stat_ft(ift)
         go to 999
      endif

      if (mimp.le.0.or.mimp.gt.iq(jmimp+2)) then
       if (mimp.eq.0) then
        print *,' tfparmft: mimp=', mimp  ! mimp ambiguous (allowed)
        go to 999
       else
        print *,' () tfparmft: mimp=', mimp  ! mimp invalid
        go to 999
       endif
      endif

      pamc(1) = fmimp_x(mimp)
     +        + fmimp_tx(mimp) * (z_zf(izf) - fmimp_z(mimp))
      pamc(2) = fmimp_y(mimp)
     +        + fmimp_ty(mimp) * (z_zf(izf) - fmimp_z(mimp))
      pamc(3) = fmimp_tx(mimp)
      pamc(4) = fmimp_ty(mimp)
      pamc(5) = tfmitoqpt(mimp)

      do i=1,5
         dpamc(i) = x(i) - pamc(i)
         ex(i)  = dsqrt(c(i,i))
         do j=1,5
            covi(i,j) = c(i,j)
         enddo
      enddo

*     **** chi2
      ch2mc = 0.

*     **** pack/invert/unpack the covariance matrix
      if (stat_ft(ift).eq.1) then
         ndf = 2
         covip(1,1) = c(1,1)
         covip(1,2) = c(1,3)
         covip(2,1) = c(3,1)
         covip(2,2) = c(3,3)
         call dsinv(ndf,covip,5,ifail)
         if (ifail.ne.0) then
            print *,' () tfparmft: inversion failed '
            go to 999
         endif
         do i=1,5
            do j=1,5
               covi(i,j) = 0.
            enddo
         enddo
         covi(1,1) = covip(1,1)
         covi(1,3) = covip(1,2)
         covi(3,1) = covip(2,1)
         covi(3,3) = covip(2,2)
      elseif (stat_ft(ift).eq.2) then
         ndf = 2
         covip(1,1) = c(2,2)
         covip(1,2) = c(2,4)
         covip(2,1) = c(4,2)
         covip(2,2) = c(4,4)
         call dsinv(ndf,covip,5,ifail)
         if (ifail.ne.0) then
            print *,' () tfparmft: inversion failed '
            go to 999
         endif
         do i=1,5
            do j=1,5
               covi(i,j) = 0.
            enddo
         enddo
         covi(2,2) = covip(1,1)
         covi(2,4) = covip(1,2)
         covi(4,2) = covip(2,1)
         covi(4,4) = covip(2,2)
      elseif (stat_ft(ift).eq.3) then
         ndf = 4
         call dsinv(ndf,covi,5,ifail)
         if (ifail.ne.0) then
            print *,' () tfparmft: inversion failed '
            go to 999
         endif
      else
         print *,' () tfparmft: invalid stat_ft=', stat_ft(ift)
         go to 999
      endif

      do i=1,ndf
         do j=1,ndf
            ch2mc = ch2mc + dpamc(i) * dpamc(j) * covi(i,j)
         enddo
      enddo

*     **** printout (factor 1000 for curvature!)
      print 101, izf, hit_zf(izf), tfmc(izf), z_zf(izf),
     +     (pamc(i), x(i), ex(i), dpamc(i), dpamc(i)/ex(i),i=1,4),
     +     (1000.*pamc(i), 1000.*x(i), 1000*ex(i), 1000.*dpamc(i),
     +     dpamc(i)/ex(i),i=5,5),
     +     ch2mc, cht_zf(izf), nhit_ft(ift)

 101  format(//
     +  '--------------------------------------------------------'/
     +  '|tfparmft analysis zf=',i4,
     +     ' ih=', i5, '  mc=', i5,'  z=', f6.0, '|'/
     +  '|------------------------------------------------------|'/
     +  '|         MC        RC       e(RC)    MC-RC   (MC-RC)/e|'/
     +  '|  x=', 5f10.5, '|'/
     +  '|  y=', 5f10.5, '|'/
     +  '| mx=', 5f10.5, '|'/
     +  '| my=', 5f10.5, '|'/
     +  '| ka=', 5f10.5, '|'/
     +  '|------------------------------------------------------|'/
     +  '| ch2mc=', f10.2, '    ch_zf=', f10.2,
     +                                    '  #hits=', i3,'      |'/
     +  '--------------------------------------------------------'
     +    )

#ifdef PPHISTS
*     **** histograms
      if (nhit_zf(izf).gt.5.and.abs(ex(5)).lt.0.05) then
       call tfphis(pamc(5),sngl(x(5)),ex(5),ch2mc,
     +                                      cht_zf(izf),nhit_zf(izf))
      endif
#endif

 999  end


