      subroutine tfversion()

************************************************************************
*                                                                      *
*  Author: Rainer Mankel                                               *
*                                                                      *
*  Creation date: 10-Nov-96                                            *
*                                                                      *
*  changed: A. Spiridonov                                              *
*                                                                      *
*  Date of fist change : 27-Okt-99                                     *
*                                                                      *
************************************************************************

*     **** print ranger version id 
      implicit none

      call mewarn('ranger 4.16/12 ')

      end


************************************************************************
* Version history:
*
* 4.16/12   Geom.C : Introduced list of active walls
*           Hit.C : few comments about hits check 
*           HitBase.C : corrected smoothing of residuals and chi2,
*           introduced ::filterOhneAbsorb, ::predictGlobal and ::absorbGlobal,
*                    faster matrix manipulation in ::absorb
*           HitWire.C : new flag NEW_MODEL, but not used
*           MatchedRsegL.C : new
*           Node.C : introduction of ::makeNode for RichRing/Rseg,
*                    correction of smoothing of residuals
*           RMap.C : Introduced ::chiSqProb
*           RichRing.C : new
*           State.C,StateL.C,StateLI.C,StateP.C,StatePI.C : moved many routines
*                      from other state classes to State.C
*           Track.C : in ::insertWalls: loop `active' volumes only,
*                      new  rangerTrack::fitGlobal(), trick for path in magnet
*           Thick.C,Thin.C : slight modification in inclusion of header files 
*           Volume.C : faster access to rotation matrix
*           Fit.C : call of t.fitGlobal() for slinemode = true
*           rgdef.C :  MC06 is included in SL MC6 
*           zfpar.fi(.hh) : new parameter sline_mode_zfpar
*           tf1init.F,tfkuip.cdf,tfkfpar.F : treatment of this new parameter 
*                      sline_mode_zfpar
*           tfcontyn.F :  parameter (y_marg=2.), flag TRIPLET_CUTY off
*           tffilmn.F : check of y coorfinate only
*           tfplx.F : new definition of sn(cs)tot_plx for VDS
*
* 4.16/11   Fit.C : new rangerFitL(vector<ArtePointer<RSEG>,..)
*           HitWire :  new flag HITWIRE_FUDGE introduced 
*           Geom.C : selective use of walls , flag GWALL_SELECT
*           rgfit.C,rgfitsv.C : include use of rangerFitL
*           tffilyn.F : strict test of y cordinate, flag FILYN_Y_TEST
*           tfunrfr.F : selective refit of PC segments
*
* 4.16/10   rghlcr.C :  added flag USER_TEST_HIT
*           tfevntr.F : remove call of tfdownstr           
*           tfunidm.F : new parameters to cut on fraction of good hits 
*           rgdownstr.C : new module to control downstream propagation
*           tftcren.F : fixed bug in filling PC-TC segments
*           StateP.C : dedx correction is off 
*   
* 4.16/09   zfpar.fi : new varables qpmax_trip_zfpar,down_mode_zfpar
*                      and qmin_down_zfpar  
*           Uniq.C :   more strict criteria for clone :
*                            hitIntersect.size() > 2
*           rghlcr.C : minor changes
*           tfevntr.F : call of downstream propagation 
*           tf1init.F : initialize new variables
*           tftripxn.F : control of qp_max via kumac parameter
*           tftcren.F : minor changes
*           tfdownstr.F : -- // --
*           tfdownse.F : call of tfdownqp(...)
*           tfdownqp.F : new, define list of q/p values for downstr. seeds
*           tfkfpar.F : 3 new kumac parameters
*           tfkuip.cdf :   -- // --
*   
* 4.16/08   Track.C : fixed problem in filling of rpnt
*           tfstseg.F : discarding of bad hits, #define BAD_HIT_DISCARD
*                       fudge factor in covariance matrix, 
*                       #define COV_COR_500MKM
*                       filling rseg->pf,pe for level=2 and 5 ,
*                       #ifdef SEG_TEST
*                       new evaluation of rseg->yf,ye ,#ifdef TY_CORRECTION 
*           tfhtseg.F   new routine used for discarding of bad hit             
*           rgauxht.C                 --  //  --
*
* 4.16/07   Track.C : in rangerTrack::orderIfNeeded()  1. check ... == zfault,
*                     2. if (nOrderFault > 0)
*           Fit.C   : filling of rseg->err instead of rseg->fit,
*                     set rtra->fit = 100 when refit fails.
*           rgfitpar.C : new, refit of segment without overwriting of rseg
*                        parameters
*           rghlcr.C  : locking of used hits during 3D propagation
*
* 4.16/06   tfstseg.F : store rseg->nhit,rseg->npar 
*                       store list of related MC produced by tfremcl(...) 
*           tfremcl.F : new, produce list of MC related to segment 
*
* 4.16/05   tfmprep.F : nhit_zf(izf)   = 1 
*
* 4.16/04   tftripxn.F #define NEW_X_MAXHIT,NEW_TRIPLETX
*           tf1init.F  new default values
*           tfcontyn.F #define NEW_Y_MAXHIT,TRIPLET_CUTY
*           tfdzone2.F #define STACK_OVER_IGNORE 
*           tfevntr.F  minor changes
*           tfpropcyn.F       parameter (w_targ = 0.25) !    
*           tfstseg.F    SEG_TEST option was added but not used
*           tfunco.F   weedout of old stuff
*           Uniq.C   if (frac1 > .5 && frac2 > .5) --> clone
*           rghl.C   locking of used hits
*           rgmaintr.C  weedout of old stuff
* 
* 4.16/03   Uniq.C bug was fixed. Added UniqA (rguniqa) for test of all 
*           segments and UniqP (rguniqp) for test in PC area. 
*           Segment is considered as clone if overlap 50% (old method)
*           tfunco.F  call of rguniqp instead of rguniq.
*           tf1init.F        segstor_zfpar = .true.    
*
* 4.16/02   Fit.C,Fit.hh,Track.C,Track.hh added function for fast fit of VDS segments
*           rgextvdmu.C minor changes
* 
* 4.16/01 - first version for real data reconstruction 
*           dev341,30/11/99 
*           tfcontyn.F changed parameters of triplet selection, unlocked used 
*           hits, excluded that triplet hits should be from different planes 
*           tfkfpar.F     set of new parameters was added 
*           tfmatripn.F   changed limits of storage loop in zf-buffer, added cut 
*                         of segment on dz  
*           tfpropcxn.F   new clean-up duplicates, use of x-target constraint 
*           tfpropcyn.F   new clean-up of duplicates, use of y-target constraint
*           tfstseg.F     new check of double hits 
*           tftcren.F     check of segment dz.gt.30 
*           tftripxn.F changed parameters of triplet selection,  
*                     excluded that triplet hits should be from different planes  
*           tffilx.F,tffilyn.F,tfmprep.F,tftctranz.F - minor changes 
*           Uniq.C        segments is considered as clone if overlap >= 2 
*           rgdom.C       creation of seeds in PC02 PC03 
*           Node.C,StateP.C,Track.C,rghl.C,rghlevnt.C - minor changes
*           new routines
*           tfevntr.F     clone of tfevnt for on-line reconstruction
*           tfunrfr.F     control routine for ranger++ fit of segments 
*                         (clone on tfunrf for on-line reconstruction)
*           tfsngold()    return # of reference golden decay in /zpstat/
*
* 4.15/04 - HitWire.C LRSign = (rhit->q)>0 ? 1 : -1; , instead of rhit->hitb->q
*           dev331,27/10/99
*
*                    ---------------------------------
*
* 4.15/03 - cut parameters in tfmatrip(n),tfpropy(n).
*           Same-plane rejection in triplet finders tftripxn.F
*           and tfcontyn.F. 
*           rgzone.C uses now entry layer to branch to next window.
*           rgzonew.C is now obsolete. 
*           Exclusion ranges from OTDR table are filled in rgdom.C.
*           Stereo angle margins in rgdom.C increased. 
*           (20-Sep-99)
* 4.15/02 - inline comments of rg*.C improved.
* 4.15/01 - rgextios.C: mmbook and mmbrel were replaced.
* 4.15/00 - Improved composite layer construction in rgdom.
*           Downstream propagation added.
*           External seed propagation added.
* 4.14/04 - Correction in tfcontyn. Some printouts changed or removed.
* 4.14/03 - Removal of stop and exit statements
* 4.14/02 - New routine tfremv.
* 4.14/01 - Muon segment treatment included in tfbuild.F
*           Pattern tracker segments stored by tfbuild.F
*           Reduced output from new navigator
* 4.14/00 - New navigator. (Many new files)
*           Many changes for modular geometry.
*           Setting of qptEst in HitBase introduced (for holmes fitting)
*           Superlayer setting in dmlay fixed.
*           tfkuip splitted.
*           dgsel selection in old navigator.
*           New parameters qualminX,qualminY,nhitmin,whitmin,
*               dgsel,navmode in zfpar.
*           Search of appropriate mimp improved in tftparm.
*           Monitor class.
* 4.13/00 - autosort in Track.C constructors, new scheme in Geom.C,
*           MS06 included in navigation table (dmdef.F),
*           modified reference track criteria because of new 
*           layer structure in magnet (tfref.F,tfstam1.F)
* 4.12/04 - RCCL copy in seg2Track.C, rgideal checks segstor before 
*           storing RTRA, no refit after pattern reco in rgmaintr,
*           no exit on dz exception in Track.C
* 4.12/03 - Bug fix in ::storeRpnt in State.hh,StateP.hh and StateP.C
* 4.12/02 - The routine rgmaintr() was introduced which is the user routine 
*           for standard main tracker reconstruction in the full geometry. 
* 4.12/01 - self-initialization, fixes in seg2track.C,tftcre.F,RMap.C,
*           removal of mc_zf,mimp_zf
* 4.12/00 - adaption to ARTE-02-05 and new C++ interface
* 4.11/00 - TC propagation, clone weedout, SVD integration, control 
*           structures
* 4.10/00 - condUpdate, hitb constructors, domain name printout, rgsv2t
* 4.09/02 - SI08 included in navigation table
* 4.09/00 - object oriented ranger fit,
*           fast magnet propagation
*           rtdir remains removed
* 4.08/02 - hardcoded domains fixed (tfdzone2.F), zmax_ec  (tfinit.F)
*           rinit (tfrfseg.F), rtdir replaced (tftpar2.F),
*           rkmain parameter list (tftrkut.F)
* 4.08/01 - modulo 2**16 in igede_sec (dmdir.F): release as ranger 4.8
* 4.08/00 - same
* 4.07/06 - new rk routines (T. Oest, T. Kuhn-Sander)
* 4.07/05 - overdue cvs add
* 4.07/04 - new include file reference scheme
*
************************************************************************
