//                              -*- Mode: C++ -*-
//: rc99AidECAL
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 4/03/00
// Last Update ........
//
// Perform particle identification using ECAL clusters and
// tracks. For matched tracks ECAL likelihoods are evaluated
// for the following hypotheses:
//     electron:     roughly e/p >0.8     lee>0.33
//     hadron:       roughly e/p <0.8     leh>0.33
//     MIP:          Ecluster<1 GeV       lemi>0.5
//
//     results are stored into the RTRA fields: lee,leh,lemi,fle
//         
//

#include "care/ECALDetector.hh"

// Prototypes
extern "C" void careelid_();

int rc99AidECAL(){

  careelid_();     // electron identification 

  return 0;
}

