
// ********************************************************************
//
//  Routine:      rc99Akapid
//  Author:       T.Oest
//
//  Description:  kuip interface to read particle id steering
//
//  Modification:
//  09 May  2000 (AG) use faComp() to check componenet
//  14 July 2000 (RP) select more than one algorithm for RICH pid
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "farm/farm.hh"

int recoPidRICH = 0;
int recoPidECAL = 0;
int recoPidMUON = 0;
int recoPidTRD  = 0;
extern int recoRICH;

extern int FADEB;

/************************************************************************
* KAPID
*
* called from  KUIP
***********************************************************************/

extern "C" void kugetc_( char*, int *, int );

extern "C" void kapid_() {   

//---------------------------------------------------------------
//   read in subdetector
//---------------------------------------------------------------

  int len;        
  int len1 = 4;
  char input[7];
  kugetc_(input, &len, len1);

  char subdetector[7];
  subdetector[len] = 0;

  for(int i=0; i<len; i++) subdetector[i] = toupper(input[i]);

//---------------------------------------------------------------
//   read in subdetetcor status
//---------------------------------------------------------------

  len1 = 3;
  kugetc_(input, &len, len1);

  char status[7];
  status[len] = 0;

  if(len>0) for(int i=0; i<len; i++) status[i] = toupper(input[i]);

//---------------------------------------------------------------
//   read in subdetetcor status
//---------------------------------------------------------------

  len1 = 5;
  kugetc_(input, &len, len1);

  char module[8];
  module[len] = 0;

  if(len>0) for(int i=0; i<len; i++) module[i] = toupper(input[i]);

//---------------------------------------------------------------
//   read in subdetetcor status
//---------------------------------------------------------------

  len1 = 5;
  kugetc_(input, &len, len1);

  char module1[8];
  module1[len] = 0;

  if(len>0) for(int i=0; i<len; i++) module1[i] = toupper(input[i]);

//---------------------------------------------------------------
//   set reconstruction status
//---------------------------------------------------------------

  int istatus = !strncmp(status,"ON",2);

  if (!strncmp(subdetector,"RICH"   ,4)) recoPidRICH     = istatus;
  if (!strncmp(subdetector,"ECAL"   ,4)) recoPidECAL     = istatus;
  if (!strncmp(subdetector,"TRD"    ,3)) recoPidTRD      = istatus;
  if (!strncmp(subdetector,"MUON"   ,4)) recoPidMUON     = istatus;

  if (recoPidRICH == 1){
   if (!strncmp(module,"RITER"   ,5)) recoPidRICH     = 1;
   if (!strncmp(module,"RIRE"    ,4)) recoPidRICH     = 2;
   if (!strncmp(module,"RISE"    ,4)) recoPidRICH     = 4;
   if (!strncmp(module1,"RITER"  ,5)) recoPidRICH     |= 1;
   if (!strncmp(module1,"RIRE"   ,4)) recoPidRICH     |= 2;
   if (!strncmp(module1,"RISE"   ,4)) recoPidRICH     |= 4;

  };

  if (!strncmp(subdetector,"ALL" ,3)) {
     recoPidRICH      = istatus;
     recoPidECAL      = istatus;
     recoPidTRD       = istatus;
     recoPidMUON      = istatus;
  };

//---------------------------------------------------------------
//   switch on RICH hit preparation if necessary
//---------------------------------------------------------------

  if (recoPidRICH !=0) recoRICH = recoRICH | 1;
  
//-----------------------------------------------------------------------------
// disable components if not present in run (faComp() returns 1 for offline)
//-----------------------------------------------------------------------------

  recoPidRICH = faComp( COMP_M_RICH ) ? recoPidRICH : 0;
  recoPidTRD  = faComp( COMP_M_TRD  ) ? recoPidTRD  : 0;
  recoPidECAL = faComp( COMP_M_ECAL ) ? recoPidECAL : 0;
  recoPidMUON = faComp( COMP_M_MUON ) ? recoPidMUON : 0;

//-----------------------------------------------------------------------------
// print
//-----------------------------------------------------------------------------

  if( FADEB ){
    cout << "KUIP: PID flags:"           << endl;
    cout << "      RICH=" << recoPidRICH << endl;
    cout << "      TRD= " << recoPidTRD  << endl;
    cout << "      ECAL=" << recoPidECAL << endl;
    cout << "      MUON=" << recoPidMUON << endl;
  }

}
