
// *****************************************************************************
//
// source:    rcSelectDVTX.C
//
// type:      source code
//
// created:   02 Aug 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcSelectDVTX
//
// called by: rcClassDVTX
//
// purpose:   selection of detached vertex events
//
// hints:     return value rc = 0 nothing selected
//
// changes:
// 02 Aug 2000 (AG) creation
// 06 Aug 2000 (AG) added selectB()
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"

// externals
extern int FADEB;

// prototypes
int copyRTRItoRTRA( int algorithm );
int selectB();

//
// function code
//
int
rcSelectDVTX()
{
  ARTE_mark( "rcSelectDVTX 0", 0 );

  copyRTRItoRTRA( 0 );

  // B decay with secondary vertex
  int b = selectB();

  // print
  if( FADEB ){
    cout << " SELECT: DVTX " 
         << "b=" << b << " "
         << endl;
   }

  ARTE_mark( "rcSelectDVTX 1", 0 );
  return b;
}
