*CMZ :          11/11/96  16.08.38  by  T. Oest
*-- Author :    T. Oest   30/05/96

      SUBROUTINE RKDV0 (UPDATE, H, EC, RKD)

************************************************************************
*
* Description: returns the derivatives for fixed POUT(1)
*
* Called from:
*
* External references:
*
* Argument in/out description
* UPDATE   in      = .TRUE. the derivatives will be updated
* H        in      step size
* FAC      in      Qc/p*sign(cos gamma)
* RKD      in/out  derivatives d POUT / d PIN
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

      DOUBLE PRECISION H, RKD(6,6)
      LOGICAL          UPDATE
      DOUBLE PRECISION RKWORK(6,6), DKDP(6,6,6), DFDP(6,6), RKCO(6,6)
      DOUBLE PRECISION SUM4, SUM5, EC, FAC, A
      INTEGER I, J, L, M, N, II, M1, M2


      DOUBLE PRECISION B(15), C(6), CST(6), PSTEPS(6,6), K(6,5)
      DOUBLE PRECISION BFIELD(6,3), FSTEPS(6,2)
      COMMON /CRKUT2/  PSTEPS, B, C, CST, K, BFIELD, FSTEPS

#include "arte/Arte.ff"

      DATA DFDP /36*0.0D0/, DKDP /216*0.0D0/
************************************************************************
* get DKDP
************************************************************************
      DFDP(2,4) = 1.0D0
      DFDP(3,5) = 1.0D0

      II  = 0
      FAC = PSTEPS(1,6)*EC
      DO I=1,6

       A   = 1.+PSTEPS(I,4)**2+PSTEPS(I,5)**2

       DFDP(4,4) =  FAC*FSTEPS(I,1) * PSTEPS(I,4) / A + FAC*SQRT(A)*
     +           (PSTEPS(I,5)*BFIELD(I,1) - 2.*PSTEPS(I,4)*BFIELD(I,2))
       DFDP(4,5) =  FAC*FSTEPS(I,1) * PSTEPS(I,5) / A + FAC*SQRT(A)*
     +           (PSTEPS(I,4)*BFIELD(I,1) + BFIELD(I,3))
       DFDP(4,6) =  EC*FSTEPS(I,1)


       DFDP(5,4) =  FAC*FSTEPS(I,2) * PSTEPS(I,4) / A - FAC*SQRT(A)*
     +           (PSTEPS(I,5)*BFIELD(I,2) + BFIELD(I,3))
       DFDP(5,5) =  FAC*FSTEPS(I,2) * PSTEPS(I,5) / A + FAC*SQRT(A)*
     +           (2.*PSTEPS(I,5)*BFIELD(I,1) - PSTEPS(I,4)*BFIELD(I,2))
       DFDP(5,6) =  EC*FSTEPS(I,2)


c dkdp =0  for J=6
       DKDP(I,1,1) = -1.0D0
       DKDP(I,2,1) = -PSTEPS(I,4)
       DKDP(I,3,1) = -PSTEPS(I,5)
       DKDP(I,4,1) = -K(I,4)/H
       DKDP(I,5,1) = -K(I,5)/H

       DKDP(I,2,4) = H
       DKDP(I,2,5) = 0.0D0
       DKDP(I,2,6) = 0.0D0

       DKDP(I,3,4) = 0.0D0
       DKDP(I,3,5) = H
       DKDP(I,3,6) = 0.0D0


       DO J=4,5
       DO L=4,6
         DKDP(I,J,L) = H * DFDP(J,L)
       ENDDO
       ENDDO


       IF (I.GT.1) THEN

       DO L=1,6
        IF (L.EQ.1 .OR. L.GE.4) THEN

         II  = (I-1)*(I-2)/2

         SUM4 = 0.0D0
         SUM5 = 0.0D0
         DO N=1,I-1
          II = II + 1
          SUM4 = SUM4 + B(II) * DKDP(N,4,L)
          SUM5 = SUM5 + B(II) * DKDP(N,5,L)
         ENDDO

         DKDP(I,2,L) = DKDP(I,2,L) + H * SUM4
         DKDP(I,3,L) = DKDP(I,3,L) + H * SUM5
         DKDP(I,4,L) = DKDP(I,4,L) + H * DFDP(4,4) * SUM4
     +                             + H * DFDP(4,5) * SUM5
         DKDP(I,5,L) = DKDP(I,5,L) + H * DFDP(5,4) * SUM4
     +                             + H * DFDP(5,5) * SUM5

        ENDIF

       ENDDO


       ENDIF

       ENDDO
************************************************************************
* derivartive matrix for this step
************************************************************************
       DO I=1,6
       DO J=1,6
        RKWORK(I,J) = 0.0D0
       ENDDO
        RKWORK(I,I) = 1.0D0
       ENDDO


c DKDP=0 for i=6

       DO I=1,5
       DO J=1,6
       DO L=1,6
        RKWORK(I,J) = RKWORK(I,J) + C(L) * DKDP(L,I,J)
       ENDDO
       ENDDO
       ENDDO

************************************************************************
* UPDATE MATRIX
************************************************************************

       IF (UPDATE) THEN

        DO I=1,6
        DO J=1,6
         RKCO(I,J) = RKD(I,J)
         RKD (I,J) = 0.0D0
        ENDDO
        ENDDO

        RKD(2,2) = 1.0D0
        RKD(3,3) = 1.0D0
        RKD(6,6) = 1.0D0

        DO J=1,6
        IF (J.EQ.1 .OR. J.GE.4) THEN
         DO I=2,5
         DO L=1,6
          RKD(I,J) = RKD(I,J) + RKWORK(I,L) * RKCO(L,J)
         ENDDO
         ENDDO
        ENDIF
        ENDDO
c        DO I=1,6
c        DO J=1,6
c        DO L=1,6
c         RKD(I,J) = RKD(I,J) + RKWORK(I,L) * RKCO(L,J)
c        ENDDO
c        ENDDO
c        ENDDO

       ELSE

        DO I=1,6
        DO J=1,6
         RKD(I,J) = RKWORK(I,J)
        ENDDO
        ENDDO

       ENDIF




      END

************************************************************************
* End of RKDERI
************************************************************************
