*CMZ :          06/11/96  12.55.46  by  T. Oest
*-- Author :    T. Oest   24/10/96

      SUBROUTINE V0LEXT(ZOUT, PIN, POUT, RKD, IERROR)

************************************************************************
*
* Description: simple track extrapolation for straight tracks
*
* Called from:
*
* External references:
*
* Argument in/out description
* ZOUT     in     z value for output parameters
* PIN(6)   in     input parameters (z,x,y,tx,ty,rho)
* POUT(6)  out    output parameters (z,x,y,tx,ty,rho)
* RKD(6,6) out    derivatives d POUT / d PIN
* IERROR   out    = 0 OK
*
*
************************************************************************

      IMPLICIT NONE


      INTEGER          IERROR
      DOUBLE PRECISION PIN(6), POUT(6), ZOUT
      DOUBLE PRECISION RKD(6,6)

      INTEGER          I, J
      DOUBLE PRECISION DZ

*-----------------------------------------------------------------------
*  new track points
*-----------------------------------------------------------------------
      IERROR = 0

      DZ = ZOUT - PIN(1)
      POUT(1) = ZOUT
      POUT(2) = PIN(2) + PIN(4) * DZ
      POUT(3) = PIN(3) + PIN(5) * DZ
      POUT(4) = PIN(4)
      POUT(5) = PIN(5)
      POUT(6) = PIN(6)
*-----------------------------------------------------------------------
*  derivatives
*-----------------------------------------------------------------------
      DO I=1,6
      DO J=1,6
       RKD(I,J) = 0.0
      ENDDO
       RKD(I,I) = 1.0
      ENDDO

      RKD(1,1) = 0.0
      RKD(2,1) = -PIN(4)
      RKD(3,1) = -PIN(5)
      RKD(2,4) = DZ 
      RKD(3,5) = DZ 
*-----------------------------------------------------------------------
* the end
*-----------------------------------------------------------------------
 9000 END

************************************************************************
* End of V0LEXT
************************************************************************
