*CMZ :          20/05/96  12.58.34  by  Unknown
*-- Author :   T.Lohse
c
c------------------------------------------------------------
c
c       subroutine:   VTFIT(iv,momflg,flag)
c
c       input:    iv       =  vertex index      Int
c                 momflg   =  flag for mom. fit Int
c
c       output:   flag   Int  < 0 if fail
c
c       action:   vertex fit for vertex iv (no constraints)
c
c------------------------------------------------------------
c
      subroutine  VTFIT ( iv, momflg, flag )

      implicit none

      integer iv, momflg
      integer flag

      integer flag1, ifail
      integer n, iter, imax, i, j, l, it

      double precision 
     1  x0(3), Vmat(5,5)

      double precision 
     1  chi2f, chi2f1

#include "vt/vtdat.fi"

      n = ntr(iv)
      iter = 0
      chi2f1 = 0.d0
      flag = 0

      if (momflg.eq.0) then
        imax = 4
      else
        imax = 5
      endif

c--->  invert the covariance matrices of the tracks
      do  i = 1, n
        it = ktr(iv,i)
        if (invflg(it).ne.imax) then
          do  j = 1, imax
            do  l = 1, imax
              Vmat(j,l) = V(j,l,it)
            enddo
          enddo
          call DSINV(imax,Vmat,5,ifail)
          if (ifail.eq.-1) then
            flag = -1
            goto 999
          endif
          invflg(it) = imax
          do  j = 1, imax
            do  l = 1, imax
              G(j,l,it) = Vmat(j,l)
            enddo
          enddo
        endif
      enddo

c--->  initialize with rough estimate of vertex
      if ( smooth(iv) .eq. 0 ) then
        if ( n .gt. 1 ) then
          call VTAVER(iv,x0)
          xvs(1,iv) = x0(1)
          xvs(2,iv) = x0(2)
          xvs(3,iv) = x0(3)
        endif
      endif

  100 continue

      iter = iter + 1

      if ( iter .eq. 10 ) then
        call VTLIN(iv,momflg,flag1)
        if ( flag1 .eq. -1 ) then
          flag = -1
          goto 999
        endif
      endif
      if (iter.gt.100) then
        flag = -2
        goto 999
      endif

      call VTFILT(iv,momflg,flag1)
      if ( flag1 .ne. 0 ) then
        flag = -1
        goto 999
      endif

      call VTSMO(iv)

      chi2f = chi2( iv, n )

      if ( abs(chi2f-chi2f1) .gt. .1 ) then
        chi2f1 = chi2f
        goto 100
      endif

  999 continue

      dist(iv) = 0

      return
      end
